searchNodes=[{"doc":"This module manages the Boolean type based on the RFC4506 XDR Standard.","ref":"XDR.Bool.html","title":"XDR.Bool","type":"module"},{"doc":"Decode the Boolean in XDR format to a XDR.Bool structure.","ref":"XDR.Bool.html#decode_xdr/2","title":"XDR.Bool.decode_xdr/2","type":"function"},{"doc":"Decode the Boolean in XDR format to a XDR.Bool structure. If the binary is not a valid boolean, an exception is raised.","ref":"XDR.Bool.html#decode_xdr!/2","title":"XDR.Bool.decode_xdr!/2","type":"function"},{"doc":"Encode a XDR.Bool structure into a XDR format.","ref":"XDR.Bool.html#encode_xdr/1","title":"XDR.Bool.encode_xdr/1","type":"function"},{"doc":"Encode a XDR.Bool structure into a XDR format. If the structure received is not XDR.Bool or the identifier is not boolean, an exception is raised.","ref":"XDR.Bool.html#encode_xdr!/1","title":"XDR.Bool.encode_xdr!/1","type":"function"},{"doc":"Create a new XDR.Bool structure from the identifier passed either false or true .","ref":"XDR.Bool.html#new/1","title":"XDR.Bool.new/1","type":"function"},{"doc":"XDR.Bool struct type specification.","ref":"XDR.Bool.html#t:t/0","title":"XDR.Bool.t/0","type":"type"},{"doc":"Behaviour definition for the types declared based on RFC4506 XDR standard.","ref":"XDR.Declaration.html","title":"XDR.Declaration","type":"behaviour"},{"doc":"Encode XDR for any type returns a tuple with the converted value.","ref":"XDR.Declaration.html#c:decode_xdr/2","title":"XDR.Declaration.decode_xdr/2","type":"callback"},{"doc":"Decode XDR for any type returns the resulted converted value.","ref":"XDR.Declaration.html#c:decode_xdr!/2","title":"XDR.Declaration.decode_xdr!/2","type":"callback"},{"doc":"Encode XDR for any type returns a tuple with the resulted binary value.","ref":"XDR.Declaration.html#c:encode_xdr/1","title":"XDR.Declaration.encode_xdr/1","type":"callback"},{"doc":"Encode XDR for any type returns the resulted binary value.","ref":"XDR.Declaration.html#c:encode_xdr!/1","title":"XDR.Declaration.encode_xdr!/1","type":"callback"},{"doc":"This module manages the Double-Precision Floating-Point type based on the RFC4506 XDR Standard.","ref":"XDR.DoubleFloat.html","title":"XDR.DoubleFloat","type":"module"},{"doc":"Decode the Double-Precision Floating-Point in XDR format to a XDR.DoubleFloat structure.","ref":"XDR.DoubleFloat.html#decode_xdr/2","title":"XDR.DoubleFloat.decode_xdr/2","type":"function"},{"doc":"Decode the Double-Precision Floating-Point in XDR format to a XDR.DoubleFloat structure. If the binaries are not valid, an exception is raised.","ref":"XDR.DoubleFloat.html#decode_xdr!/2","title":"XDR.DoubleFloat.decode_xdr!/2","type":"function"},{"doc":"Encode a XDR.DoubleFloat structure into a XDR format.","ref":"XDR.DoubleFloat.html#encode_xdr/1","title":"XDR.DoubleFloat.encode_xdr/1","type":"function"},{"doc":"Encode a XDR.DoubleFloat structure into a XDR format. If the double_float is not valid, an exception is raised.","ref":"XDR.DoubleFloat.html#encode_xdr!/1","title":"XDR.DoubleFloat.encode_xdr!/1","type":"function"},{"doc":"Create a new XDR.DoubleFloat structure from the float passed.","ref":"XDR.DoubleFloat.html#new/1","title":"XDR.DoubleFloat.new/1","type":"function"},{"doc":"","ref":"XDR.DoubleFloat.html#valid_float?/1","title":"XDR.DoubleFloat.valid_float?/1","type":"macro"},{"doc":"","ref":"XDR.DoubleFloat.html#t:float_number/0","title":"XDR.DoubleFloat.float_number/0","type":"type"},{"doc":"XDR.DoubleFloat struct type specification.","ref":"XDR.DoubleFloat.html#t:t/0","title":"XDR.DoubleFloat.t/0","type":"type"},{"doc":"This module manages the Enumeration type based on the RFC4506 XDR Standard.","ref":"XDR.Enum.html","title":"XDR.Enum","type":"module"},{"doc":"Decode the Enumeration in XDR format to a XDR.Enum structure.","ref":"XDR.Enum.html#decode_xdr/2","title":"XDR.Enum.decode_xdr/2","type":"function"},{"doc":"Decode the Enumeration in XDR format to a XDR.Enum structure. If the binaries are not valid, an exception is raised.","ref":"XDR.Enum.html#decode_xdr!/2","title":"XDR.Enum.decode_xdr!/2","type":"function"},{"doc":"Encode a XDR.Enum structure into a XDR format.","ref":"XDR.Enum.html#encode_xdr/1","title":"XDR.Enum.encode_xdr/1","type":"function"},{"doc":"Encode a XDR.Enum structure into a XDR format. If the declarations or identifier of the enum is not valid, an exception is raised.","ref":"XDR.Enum.html#encode_xdr!/1","title":"XDR.Enum.encode_xdr!/1","type":"function"},{"doc":"Create a new XDR.Enum structure with the declarations and identifier passed.","ref":"XDR.Enum.html#new/2","title":"XDR.Enum.new/2","type":"function"},{"doc":"XDR.Enum structure type specification.","ref":"XDR.Enum.html#t:t/0","title":"XDR.Enum.t/0","type":"type"},{"doc":"This module manages the Fixed-Length Array type based on the RFC4506 XDR Standard.","ref":"XDR.FixedArray.html","title":"XDR.FixedArray","type":"module"},{"doc":"Decode the Fixed-Length Array in XDR format to a XDR.FixedArray structure.","ref":"XDR.FixedArray.html#decode_xdr/2","title":"XDR.FixedArray.decode_xdr/2","type":"function"},{"doc":"Decode the Fixed-Length Array in XDR format to a XDR.FixedArray structure. If the binaries are not valid, an exception is raised.","ref":"XDR.FixedArray.html#decode_xdr!/2","title":"XDR.FixedArray.decode_xdr!/2","type":"function"},{"doc":"Encode a XDR.FixedArray structure into a XDR format.","ref":"XDR.FixedArray.html#encode_xdr/1","title":"XDR.FixedArray.encode_xdr/1","type":"function"},{"doc":"Encode a XDR.FixedArray structure into a XDR format. If the fixed_array is not valid, an exception is raised.","ref":"XDR.FixedArray.html#encode_xdr!/1","title":"XDR.FixedArray.encode_xdr!/1","type":"function"},{"doc":"Create a new XDR.FixedArray structure with the elements , type and length passed.","ref":"XDR.FixedArray.html#new/3","title":"XDR.FixedArray.new/3","type":"function"},{"doc":"","ref":"XDR.FixedArray.html#t:elements/0","title":"XDR.FixedArray.elements/0","type":"type"},{"doc":"XDR.FixedArray structure type specification.","ref":"XDR.FixedArray.html#t:t/0","title":"XDR.FixedArray.t/0","type":"type"},{"doc":"This module manages the Fixed-Length Opaque Data type based on the RFC4506 XDR Standard.","ref":"XDR.FixedOpaque.html","title":"XDR.FixedOpaque","type":"module"},{"doc":"Decode the Fixed-Length Opaque Data in XDR format to a XDR.FixedOpaque structure.","ref":"XDR.FixedOpaque.html#decode_xdr/2","title":"XDR.FixedOpaque.decode_xdr/2","type":"function"},{"doc":"Decode the Fixed-Length Array in XDR format to a XDR.FixedOpaque structure. If the binaries are not valid, an exception is raised.","ref":"XDR.FixedOpaque.html#decode_xdr!/2","title":"XDR.FixedOpaque.decode_xdr!/2","type":"function"},{"doc":"Encode a XDR.FixedOpaque structure into a XDR format.","ref":"XDR.FixedOpaque.html#encode_xdr/1","title":"XDR.FixedOpaque.encode_xdr/1","type":"function"},{"doc":"Encode a XDR.FixedOpaque structure into a XDR format. If the opaque is not valid, an exception is raised.","ref":"XDR.FixedOpaque.html#encode_xdr!/1","title":"XDR.FixedOpaque.encode_xdr!/1","type":"function"},{"doc":"Create a new XDR.FixedOpaque structure with the opaque and length passed.","ref":"XDR.FixedOpaque.html#new/2","title":"XDR.FixedOpaque.new/2","type":"function"},{"doc":"","ref":"XDR.FixedOpaque.html#t:opaque/0","title":"XDR.FixedOpaque.opaque/0","type":"type"},{"doc":"XDR.FixedOpaque structure type specification.","ref":"XDR.FixedOpaque.html#t:t/0","title":"XDR.FixedOpaque.t/0","type":"type"},{"doc":"This module manages the Floating-Point type based on the RFC4506 XDR Standard.","ref":"XDR.Float.html","title":"XDR.Float","type":"module"},{"doc":"Decode the Floating-Point in XDR format to a XDR.Float structure.","ref":"XDR.Float.html#decode_xdr/2","title":"XDR.Float.decode_xdr/2","type":"function"},{"doc":"Decode the Floating-Point in XDR format to a XDR.Float structure. If the binaries are not valid, an exception is raised.","ref":"XDR.Float.html#decode_xdr!/2","title":"XDR.Float.decode_xdr!/2","type":"function"},{"doc":"Encode a XDR.Float structure into a XDR format.","ref":"XDR.Float.html#encode_xdr/1","title":"XDR.Float.encode_xdr/1","type":"function"},{"doc":"Encode a XDR.Float structure into a XDR format. If the float is not valid, an exception is raised.","ref":"XDR.Float.html#encode_xdr!/1","title":"XDR.Float.encode_xdr!/1","type":"function"},{"doc":"Create a new XDR.Float structure with the float passed.","ref":"XDR.Float.html#new/1","title":"XDR.Float.new/1","type":"function"},{"doc":"","ref":"XDR.Float.html#valid_float?/1","title":"XDR.Float.valid_float?/1","type":"macro"},{"doc":"","ref":"XDR.Float.html#t:float_number/0","title":"XDR.Float.float_number/0","type":"type"},{"doc":"XDR.Float structure type specification.","ref":"XDR.Float.html#t:t/0","title":"XDR.Float.t/0","type":"type"},{"doc":"This module manages the Hyper Integer type based on the RFC4506 XDR Standard.","ref":"XDR.HyperInt.html","title":"XDR.HyperInt","type":"module"},{"doc":"Decode the Hyper Integer in XDR format to a XDR.HyperInt structure.","ref":"XDR.HyperInt.html#decode_xdr/2","title":"XDR.HyperInt.decode_xdr/2","type":"function"},{"doc":"Decode the Hyper Integer in XDR format to a XDR.HyperInt structure. If the binaries are not valid, an exception is raised.","ref":"XDR.HyperInt.html#decode_xdr!/2","title":"XDR.HyperInt.decode_xdr!/2","type":"function"},{"doc":"Encode a XDR.HyperInt structure into a XDR format.","ref":"XDR.HyperInt.html#encode_xdr/1","title":"XDR.HyperInt.encode_xdr/1","type":"function"},{"doc":"Encode a XDR.HyperInt structure into a XDR format. If the h_int is not valid, an exception is raised.","ref":"XDR.HyperInt.html#encode_xdr!/1","title":"XDR.HyperInt.encode_xdr!/1","type":"function"},{"doc":"Create a new XDR.HyperInt structure with the datum passed.","ref":"XDR.HyperInt.html#new/1","title":"XDR.HyperInt.new/1","type":"function"},{"doc":"","ref":"XDR.HyperInt.html#t:datum/0","title":"XDR.HyperInt.datum/0","type":"type"},{"doc":"XDR.HyperInt structure type specification.","ref":"XDR.HyperInt.html#t:t/0","title":"XDR.HyperInt.t/0","type":"type"},{"doc":"This module manages the Unsigned Hyper Integer type based on the RFC4506 XDR Standard.","ref":"XDR.HyperUInt.html","title":"XDR.HyperUInt","type":"module"},{"doc":"Decode the Unsigned Hyper Integer in XDR format to a XDR.HyperUInt structure.","ref":"XDR.HyperUInt.html#decode_xdr/2","title":"XDR.HyperUInt.decode_xdr/2","type":"function"},{"doc":"Decode the Unsigned Hyper Integer in XDR format to a XDR.HyperUInt structure. If the binaries are not valid, an exception is raised.","ref":"XDR.HyperUInt.html#decode_xdr!/2","title":"XDR.HyperUInt.decode_xdr!/2","type":"function"},{"doc":"Encode a XDR.HyperUInt structure into a XDR format.","ref":"XDR.HyperUInt.html#encode_xdr/1","title":"XDR.HyperUInt.encode_xdr/1","type":"function"},{"doc":"Encode a XDR.HyperUInt structure into a XDR format. If the h_uint is not valid, an exception is raised.","ref":"XDR.HyperUInt.html#encode_xdr!/1","title":"XDR.HyperUInt.encode_xdr!/1","type":"function"},{"doc":"Create a new XDR.HyperUInt structure with the opaque and length passed.","ref":"XDR.HyperUInt.html#new/1","title":"XDR.HyperUInt.new/1","type":"function"},{"doc":"","ref":"XDR.HyperUInt.html#t:datum/0","title":"XDR.HyperUInt.datum/0","type":"type"},{"doc":"XDR.HyperUInt structure type specification.","ref":"XDR.HyperUInt.html#t:t/0","title":"XDR.HyperUInt.t/0","type":"type"},{"doc":"This module manages the Integer type based on the RFC4506 XDR Standard.","ref":"XDR.Int.html","title":"XDR.Int","type":"module"},{"doc":"Decode the Integer in XDR format to a XDR.Int structure.","ref":"XDR.Int.html#decode_xdr/2","title":"XDR.Int.decode_xdr/2","type":"function"},{"doc":"Decode the Integer in XDR format to a XDR.Int structure. If the binaries are not valid, an exception is raised.","ref":"XDR.Int.html#decode_xdr!/2","title":"XDR.Int.decode_xdr!/2","type":"function"},{"doc":"Encode a XDR.Int structure into a XDR format.","ref":"XDR.Int.html#encode_xdr/1","title":"XDR.Int.encode_xdr/1","type":"function"},{"doc":"Encode a XDR.Int structure into a XDR format. If the int is not valid, an exception is raised.","ref":"XDR.Int.html#encode_xdr!/1","title":"XDR.Int.encode_xdr!/1","type":"function"},{"doc":"Create a new XDR.Int structure with the opaque and length passed.","ref":"XDR.Int.html#new/1","title":"XDR.Int.new/1","type":"function"},{"doc":"XDR.Int structure type specification.","ref":"XDR.Int.html#t:t/0","title":"XDR.Int.t/0","type":"type"},{"doc":"This module manages the Optional-Data type based on the RFC4506 XDR Standard.","ref":"XDR.Optional.html","title":"XDR.Optional","type":"module"},{"doc":"Decode the Optional-Data in XDR format to a XDR.Optional structure.","ref":"XDR.Optional.html#decode_xdr/2","title":"XDR.Optional.decode_xdr/2","type":"function"},{"doc":"Decode the Optional-Data in XDR format to a XDR.Optional structure. If the binaries are not valid, an exception is raised.","ref":"XDR.Optional.html#decode_xdr!/2","title":"XDR.Optional.decode_xdr!/2","type":"function"},{"doc":"Encode a XDR.Optional structure into a XDR format.","ref":"XDR.Optional.html#encode_xdr/1","title":"XDR.Optional.encode_xdr/1","type":"function"},{"doc":"Encode a XDR.Optional structure into a XDR format. If the optional is not valid, an exception is raised.","ref":"XDR.Optional.html#encode_xdr!/1","title":"XDR.Optional.encode_xdr!/1","type":"function"},{"doc":"Create a new XDR.Optional structure with the type passed.","ref":"XDR.Optional.html#new/1","title":"XDR.Optional.new/1","type":"function"},{"doc":"XDR.Optional structure type specification.","ref":"XDR.Optional.html#t:t/0","title":"XDR.Optional.t/0","type":"type"},{"doc":"This module is not supported by the actual byte size","ref":"XDR.QuadFloat.html","title":"XDR.QuadFloat","type":"module"},{"doc":"not supported","ref":"XDR.QuadFloat.html#decode_xdr/2","title":"XDR.QuadFloat.decode_xdr/2","type":"function"},{"doc":"not supported","ref":"XDR.QuadFloat.html#decode_xdr!/2","title":"XDR.QuadFloat.decode_xdr!/2","type":"function"},{"doc":"not supported","ref":"XDR.QuadFloat.html#encode_xdr/1","title":"XDR.QuadFloat.encode_xdr/1","type":"function"},{"doc":"not supported","ref":"XDR.QuadFloat.html#encode_xdr!/1","title":"XDR.QuadFloat.encode_xdr!/1","type":"function"},{"doc":"This module manages the String type based on the RFC4506 XDR Standard.","ref":"XDR.String.html","title":"XDR.String","type":"module"},{"doc":"Decode the String in XDR format to a XDR.String structure.","ref":"XDR.String.html#decode_xdr/2","title":"XDR.String.decode_xdr/2","type":"function"},{"doc":"Decode the String in XDR format to a XDR.String structure. If the binaries are not valid, an exception is raised.","ref":"XDR.String.html#decode_xdr!/2","title":"XDR.String.decode_xdr!/2","type":"function"},{"doc":"Encode a XDR.String structure into a XDR format.","ref":"XDR.String.html#encode_xdr/1","title":"XDR.String.encode_xdr/1","type":"function"},{"doc":"Encode a XDR.String structure into a XDR format. If the string is not valid, an exception is raised.","ref":"XDR.String.html#encode_xdr!/1","title":"XDR.String.encode_xdr!/1","type":"function"},{"doc":"Create a new XDR.String structure with the opaque and length passed.","ref":"XDR.String.html#new/2","title":"XDR.String.new/2","type":"function"},{"doc":"XDR.String structure type specification.","ref":"XDR.String.html#t:t/0","title":"XDR.String.t/0","type":"type"},{"doc":"This module manages the Structure type based on the RFC4506 XDR Standard.","ref":"XDR.Struct.html","title":"XDR.Struct","type":"module"},{"doc":"Decode the Structure in XDR format to a XDR.Struct structure.","ref":"XDR.Struct.html#decode_xdr/2","title":"XDR.Struct.decode_xdr/2","type":"function"},{"doc":"Decode the Structure in XDR format to a XDR.Struct structure. If the binaries are not valid, an exception is raised.","ref":"XDR.Struct.html#decode_xdr!/2","title":"XDR.Struct.decode_xdr!/2","type":"function"},{"doc":"Encode a XDR.Struct structure into a XDR format.","ref":"XDR.Struct.html#encode_xdr/1","title":"XDR.Struct.encode_xdr/1","type":"function"},{"doc":"Encode a XDR.Struct structure into a XDR format. If the struct is not valid, an exception is raised.","ref":"XDR.Struct.html#encode_xdr!/1","title":"XDR.Struct.encode_xdr!/1","type":"function"},{"doc":"Create a new XDR.Struct structure with the opaque and length passed.","ref":"XDR.Struct.html#new/1","title":"XDR.Struct.new/1","type":"function"},{"doc":"XDR.Struct structure type specification.","ref":"XDR.Struct.html#t:t/0","title":"XDR.Struct.t/0","type":"type"},{"doc":"This module manages the Unsigned Integer type based on the RFC4506 XDR Standard.","ref":"XDR.UInt.html","title":"XDR.UInt","type":"module"},{"doc":"Decode the Unsigned Integer in XDR format to a XDR.UInt structure.","ref":"XDR.UInt.html#decode_xdr/2","title":"XDR.UInt.decode_xdr/2","type":"function"},{"doc":"Decode the Unsigned Integer in XDR format to a XDR.UInt structure. If the binaries are not valid, an exception is raised.","ref":"XDR.UInt.html#decode_xdr!/2","title":"XDR.UInt.decode_xdr!/2","type":"function"},{"doc":"Encode a XDR.UInt structure into a XDR format.","ref":"XDR.UInt.html#encode_xdr/1","title":"XDR.UInt.encode_xdr/1","type":"function"},{"doc":"Encode a XDR.UInt structure into a XDR format. If the u_int is not valid, an exception is raised.","ref":"XDR.UInt.html#encode_xdr!/1","title":"XDR.UInt.encode_xdr!/1","type":"function"},{"doc":"Create a new XDR.UInt structure with the datum passed.","ref":"XDR.UInt.html#new/1","title":"XDR.UInt.new/1","type":"function"},{"doc":"","ref":"XDR.UInt.html#t:datum/0","title":"XDR.UInt.datum/0","type":"type"},{"doc":"XDR.UInt structure type specification.","ref":"XDR.UInt.html#t:t/0","title":"XDR.UInt.t/0","type":"type"},{"doc":"This module manages the Discriminated Union type based on the RFC4506 XDR Standard.","ref":"XDR.Union.html","title":"XDR.Union","type":"module"},{"doc":"Decode the Discriminated Union in XDR format to a XDR.Union structure.","ref":"XDR.Union.html#decode_xdr/2","title":"XDR.Union.decode_xdr/2","type":"function"},{"doc":"Decode the Discriminated Union in XDR format to a XDR.Union structure. If the binaries are not valid, an exception is raised.","ref":"XDR.Union.html#decode_xdr!/2","title":"XDR.Union.decode_xdr!/2","type":"function"},{"doc":"Encode a XDR.Union structure into a XDR format.","ref":"XDR.Union.html#encode_xdr/1","title":"XDR.Union.encode_xdr/1","type":"function"},{"doc":"Encode a XDR.Union structure into a XDR format. If the union is not valid, an exception is raised.","ref":"XDR.Union.html#encode_xdr!/1","title":"XDR.Union.encode_xdr!/1","type":"function"},{"doc":"Create a new XDR.Union structure with the discriminant , arms and value passed.","ref":"XDR.Union.html#new/3","title":"XDR.Union.new/3","type":"function"},{"doc":"","ref":"XDR.Union.html#t:arms/0","title":"XDR.Union.arms/0","type":"type"},{"doc":"","ref":"XDR.Union.html#t:discriminant/0","title":"XDR.Union.discriminant/0","type":"type"},{"doc":"XDR.Union structure type specification.","ref":"XDR.Union.html#t:t/0","title":"XDR.Union.t/0","type":"type"},{"doc":"This module manages the Variable-Length Array type based on the RFC4506 XDR Standard.","ref":"XDR.VariableArray.html","title":"XDR.VariableArray","type":"module"},{"doc":"Decode the Variable-Length Array in XDR format to a XDR.VariableArray structure.","ref":"XDR.VariableArray.html#decode_xdr/2","title":"XDR.VariableArray.decode_xdr/2","type":"function"},{"doc":"Decode the Variable-Length Array in XDR format to a XDR.VariableArray structure. If the binaries are not valid, an exception is raised.","ref":"XDR.VariableArray.html#decode_xdr!/2","title":"XDR.VariableArray.decode_xdr!/2","type":"function"},{"doc":"Encode a XDR.VariableArray structure into a XDR format.","ref":"XDR.VariableArray.html#encode_xdr/1","title":"XDR.VariableArray.encode_xdr/1","type":"function"},{"doc":"Encode a XDR.VariableArray structure into a XDR format. If the variable_array is not valid, an exception is raised.","ref":"XDR.VariableArray.html#encode_xdr!/1","title":"XDR.VariableArray.encode_xdr!/1","type":"function"},{"doc":"Create a new XDR.VariableArray structure with the elements , type and max_length passed.","ref":"XDR.VariableArray.html#new/3","title":"XDR.VariableArray.new/3","type":"function"},{"doc":"","ref":"XDR.VariableArray.html#t:elements/0","title":"XDR.VariableArray.elements/0","type":"type"},{"doc":"XDR.VariableArray structure type specification.","ref":"XDR.VariableArray.html#t:t/0","title":"XDR.VariableArray.t/0","type":"type"},{"doc":"This module manages the Variable-Length Opaque Data type based on the RFC4506 XDR Standard.","ref":"XDR.VariableOpaque.html","title":"XDR.VariableOpaque","type":"module"},{"doc":"Decode the Variable-Length Opaque Data in XDR format to a XDR.VariableOpaque structure.","ref":"XDR.VariableOpaque.html#decode_xdr/2","title":"XDR.VariableOpaque.decode_xdr/2","type":"function"},{"doc":"Decode the Variable-Length Opaque Data in XDR format to a XDR.VariableOpaque structure. If the binaries are not valid, an exception is raised.","ref":"XDR.VariableOpaque.html#decode_xdr!/2","title":"XDR.VariableOpaque.decode_xdr!/2","type":"function"},{"doc":"Encode a XDR.VariableOpaque structure into a XDR format.","ref":"XDR.VariableOpaque.html#encode_xdr/1","title":"XDR.VariableOpaque.encode_xdr/1","type":"function"},{"doc":"Encode a XDR.VariableOpaque structure into a XDR format. If the opaque is not valid, an exception is raised.","ref":"XDR.VariableOpaque.html#encode_xdr!/1","title":"XDR.VariableOpaque.encode_xdr!/1","type":"function"},{"doc":"Create a new XDR.VariableOpaque structure with the opaque and max_size passed.","ref":"XDR.VariableOpaque.html#new/2","title":"XDR.VariableOpaque.new/2","type":"function"},{"doc":"","ref":"XDR.VariableOpaque.html#t:opaque/0","title":"XDR.VariableOpaque.opaque/0","type":"type"},{"doc":"XDR.VariableOpaque structure type specification.","ref":"XDR.VariableOpaque.html#t:t/0","title":"XDR.VariableOpaque.t/0","type":"type"},{"doc":"This module manages the Void type based on the RFC4506 XDR Standard.","ref":"XDR.Void.html","title":"XDR.Void","type":"module"},{"doc":"Decode the XDR format to a void format.","ref":"XDR.Void.html#decode_xdr/2","title":"XDR.Void.decode_xdr/2","type":"function"},{"doc":"Decode the XDR format to a void format. If the binary is not a valid void, an exception is raised.","ref":"XDR.Void.html#decode_xdr!/2","title":"XDR.Void.decode_xdr!/2","type":"function"},{"doc":"Encode a XDR.Void structure into a XDR format.","ref":"XDR.Void.html#encode_xdr/1","title":"XDR.Void.encode_xdr/1","type":"function"},{"doc":"Encode a XDR.Void structure into a XDR format. If the structure received is not XDR.Void , an exception is raised.","ref":"XDR.Void.html#encode_xdr!/1","title":"XDR.Void.encode_xdr!/1","type":"function"},{"doc":"Create a new XDR.Void structure from the value passed.","ref":"XDR.Void.html#new/1","title":"XDR.Void.new/1","type":"function"},{"doc":"XDR.Void struct type specification.","ref":"XDR.Void.html#t:t/0","title":"XDR.Void.t/0","type":"type"},{"doc":"This module contains the definition of XDR.BoolError exception that may be raised by the XDR.Bool module.","ref":"XDR.BoolError.html","title":"XDR.BoolError","type":"exception"},{"doc":"Create a XDR.BoolError exception with the message of the error_type passed.","ref":"XDR.BoolError.html#exception/1","title":"XDR.BoolError.exception/1","type":"function"},{"doc":"This module contains the definition of XDR.DoubleFloatError exception that may be raised by the XDR.DoubleFloat module.","ref":"XDR.DoubleFloatError.html","title":"XDR.DoubleFloatError","type":"exception"},{"doc":"Create a XDR.DoubleFloatError exception with the message of the error_type passed.","ref":"XDR.DoubleFloatError.html#exception/1","title":"XDR.DoubleFloatError.exception/1","type":"function"},{"doc":"This module contains the definition of XDR.EnumError exception that may be raised by the XDR.Enum module.","ref":"XDR.EnumError.html","title":"XDR.EnumError","type":"exception"},{"doc":"Create a XDR.EnumError exception with the message of the error_type passed.","ref":"XDR.EnumError.html#exception/1","title":"XDR.EnumError.exception/1","type":"function"},{"doc":"This module contains the definition of XDR.FixedArrayError exception that may be raised by the XDR.FixedArray module.","ref":"XDR.FixedArrayError.html","title":"XDR.FixedArrayError","type":"exception"},{"doc":"Create a XDR.FixedArrayError exception with the message of the error_type passed.","ref":"XDR.FixedArrayError.html#exception/1","title":"XDR.FixedArrayError.exception/1","type":"function"},{"doc":"This module contains the definition of XDR.FixedOpaqueError exception that may be raised by the XDR.FixedOpaque module.","ref":"XDR.FixedOpaqueError.html","title":"XDR.FixedOpaqueError","type":"exception"},{"doc":"Create a XDR.FixedOpaqueError exception with the message of the error_type passed.","ref":"XDR.FixedOpaqueError.html#exception/1","title":"XDR.FixedOpaqueError.exception/1","type":"function"},{"doc":"This module contains the definition of XDR.FloatError exception that may be raised by the XDR.Float module.","ref":"XDR.FloatError.html","title":"XDR.FloatError","type":"exception"},{"doc":"Create a XDR.FloatError exception with the message of the error_type passed.","ref":"XDR.FloatError.html#exception/1","title":"XDR.FloatError.exception/1","type":"function"},{"doc":"This module contains the definition of XDR.HyperIntError exception that may be raised by the XDR.HyperInt module.","ref":"XDR.HyperIntError.html","title":"XDR.HyperIntError","type":"exception"},{"doc":"Create a XDR.HyperIntError exception with the message of the error_type passed.","ref":"XDR.HyperIntError.html#exception/1","title":"XDR.HyperIntError.exception/1","type":"function"},{"doc":"This module contains the definition of XDR.HyperUIntError exception that may be raised by the XDR.HyperUInt module.","ref":"XDR.HyperUIntError.html","title":"XDR.HyperUIntError","type":"exception"},{"doc":"Create a XDR.HyperUIntError exception with the message of the error_type passed.","ref":"XDR.HyperUIntError.html#exception/1","title":"XDR.HyperUIntError.exception/1","type":"function"},{"doc":"This module contains the definition of XDR.IntError exception that may be raised by the XDR.Int module.","ref":"XDR.IntError.html","title":"XDR.IntError","type":"exception"},{"doc":"Create a XDR.IntError exception with the message of the error_type passed.","ref":"XDR.IntError.html#exception/1","title":"XDR.IntError.exception/1","type":"function"},{"doc":"This module contains the definition of XDR.OptionalError exception that may be raised by the XDR.Optional module.","ref":"XDR.OptionalError.html","title":"XDR.OptionalError","type":"exception"},{"doc":"Create a XDR.OptionalError exception with the message of the error_type passed.","ref":"XDR.OptionalError.html#exception/1","title":"XDR.OptionalError.exception/1","type":"function"},{"doc":"This module contains the definition of XDR.StringError exception that may be raised by the XDR.String module.","ref":"XDR.StringError.html","title":"XDR.StringError","type":"exception"},{"doc":"Create a XDR.StringError exception with the message of the error_type passed.","ref":"XDR.StringError.html#exception/1","title":"XDR.StringError.exception/1","type":"function"},{"doc":"This module contains the definition of XDR.StructError exception that may be raised by the XDR.Struct module.","ref":"XDR.StructError.html","title":"XDR.StructError","type":"exception"},{"doc":"Create a XDR.StructError exception with the message of the error_type passed.","ref":"XDR.StructError.html#exception/1","title":"XDR.StructError.exception/1","type":"function"},{"doc":"This module contains the definition of XDR.UIntError exception that may be raised by the XDR.UInt module.","ref":"XDR.UIntError.html","title":"XDR.UIntError","type":"exception"},{"doc":"Create a XDR.UIntError exception with the message of the error_type passed.","ref":"XDR.UIntError.html#exception/1","title":"XDR.UIntError.exception/1","type":"function"},{"doc":"This module contains the definition of XDR.UnionError exception that may be raised by the XDR.Union module.","ref":"XDR.UnionError.html","title":"XDR.UnionError","type":"exception"},{"doc":"Create a XDR.UnionError exception with the message of the error_type passed.","ref":"XDR.UnionError.html#exception/1","title":"XDR.UnionError.exception/1","type":"function"},{"doc":"This module contains the definition of XDR.VariableArrayError exception that may be raised by the XDR.VariableArray module.","ref":"XDR.VariableArrayError.html","title":"XDR.VariableArrayError","type":"exception"},{"doc":"Create a XDR.VariableArrayError exception with the message of the error_type passed.","ref":"XDR.VariableArrayError.html#exception/1","title":"XDR.VariableArrayError.exception/1","type":"function"},{"doc":"This module contains the definition of XDR.VariableOpaqueError exception that may be raised by the XDR.VariableOpaque module.","ref":"XDR.VariableOpaqueError.html","title":"XDR.VariableOpaqueError","type":"exception"},{"doc":"Create a XDR.VariableOpaqueError exception with the message of the error_type passed.","ref":"XDR.VariableOpaqueError.html#exception/1","title":"XDR.VariableOpaqueError.exception/1","type":"function"},{"doc":"This module contains the definition of XDR.VoidError exception that may be raised by the XDR.Void module.","ref":"XDR.VoidError.html","title":"XDR.VoidError","type":"exception"},{"doc":"Create a XDR.VoidError exception with the message of the error_type passed.","ref":"XDR.VoidError.html#exception/1","title":"XDR.VoidError.exception/1","type":"function"},{"doc":"Elixir XDR XDR is an open data format, specified in RFC 4506 . This library provides a way to decode and encode XDR data from Elixir. Extend with ease to other XDR types.","ref":"readme.html","title":"Elixir XDR","type":"extras"},{"doc":"Available in Hex , Add elixir_xdr to your dependencies list in mix.exs : def deps do [ { :elixir_xdr , &quot;~&gt; 0.3.1&quot; } ] end","ref":"readme.html#installation","title":"Elixir XDR - Installation","type":"extras"},{"doc":"The following XDR types are completely implemented in this library: # Basic types XDR.Int # Section 4.1 XDR.UInt # Section 4.2 XDR.Bool # Section 4.4 XDR.HyperInt # Section 4.5 XDR.HyperUInt # Section 4.5 XDR.Float # Section 4.6 XDR.DoubleFloat # Section 4.7 XDR.Void # Section 4.16 # Complex types XDR.Enum # Section 4.3 XDR.FixedOpaque # Section 4.9 XDR.VariableOpaque # Section 4.10 XDR.String # Section 4.11 XDR.FixedArray # Section 4.12 XDR.VariableArray # Section 4.13 XDR.Struct # Section 4.14 XDR.Union # Section 4.15 XDR.Optional # Section 4.19 The following types were not implemented: XDR.QuadFloat # Section 4.8, not supported for 128-byte size. XDR.Const # Section 4.17, can be replaced with elixir constants. XDR.Typedef # Section 4.18, may be implemented with elixir modules. More info bellow in this guide.","ref":"readme.html#implemented-types","title":"Elixir XDR - Implemented types","type":"extras"},{"doc":"It is an Open Source project, not a code that only I understand. Macros are harder to write than ordinary Elixir functions, implementing them increases the code complexity, which is not good, especially if you plan to build an Open Source code that is easy to understand for everyone. We decided to go without macros, we want to let everyone expand or implement their own XDR types with a clear model based on Elixir functions.","ref":"readme.html#better-without-macros","title":"Elixir XDR - Better without macros","type":"extras"},{"doc":"Behaviour is the key . When implementing a new XDR type, follow this Behaviour's Declaration . For Encoding We use the function encode_xdr/2 or the bang version encode_xdr!/2 to encode any XDR type to its XDR binary format. For Decoding We use the function decode_xdr/2 or the bang version decode_xdr!/2 to decode any XDR type from an XDR binary format. In most XDR types, we must pass the type specification , it is a struct (or map) with the XDR type attributes that is expected to decode. iex(1)&gt; enum_spec = XDR.Enum . new ( [ false : 0 , true : 1 ] , nil ) # preferred. % XDR.Enum { declarations : [ false : 0 , true : 1 ] , identifier : nil } iex(2)&gt; XDR.Enum . decode_xdr ( &lt;&lt; 0 , 0 , 0 , 1 &gt;&gt; , enum_spec ) iex(1)&gt; enum_spec = %{ declarations : [ false : 0 , true : 1 ] } iex(2)&gt; XDR.Enum . decode_xdr! ( &lt;&lt; 0 , 0 , 0 , 0 &gt;&gt; , enum_spec ) { % XDR.Enum { declarations : [ false : 0 , true : 1 ] , identifier : false } , &lt;&lt; &gt;&gt; } For all XDR types, encoded binaries may overflow the byte(s) size, that is why the returning value for decoding functions is set to be a tuple. The first element holds the XDR type decoded and the second element holds the remaining binary after decoding. iex(1)&gt; { decoded_part , remaining_part } = XDR.Int . decode_xdr! ( &lt;&lt; 127 , 255 , 255 , 255 , 5 &gt;&gt; ) { { % XDR.Int { datum : 2147483647 } , &lt;&lt; 5 &gt;&gt; } } # decoded_part = %XDR.Int{datum: 2147483647} # remaining_part = &lt;&lt;5&gt;&gt;","ref":"readme.html#how-to-implement-an-xdr-type","title":"Elixir XDR - How to implement an XDR type?","type":"extras"},{"doc":"As mentioned before, all the XDR types follow the same Behaviour's Declaration XDR.Int - Integer An XDR signed integer is a 32-bit datum that encodes an integer in the range [-2_147_483_648, 2_147_483_647] . Encoding: iex(1)&gt; XDR.Int . new ( 1234 ) |&gt; XDR.Int . encode_xdr ( ) { :ok , &lt;&lt; 0 , 0 , 4 , 210 &gt;&gt; } iex(1)&gt; XDR.Int . new ( 1234 ) |&gt; XDR.Int . encode_xdr! ( ) &lt;&lt; 0 , 0 , 4 , 210 &gt;&gt; Decoding: iex(1)&gt; XDR.Int . decode_xdr ( &lt;&lt; 0 , 0 , 4 , 210 &gt;&gt; ) { :ok , { % XDR.Int { datum : 1234 } , &lt;&lt; &gt;&gt; } } iex(1)&gt; XDR.Int . decode_xdr! ( &lt;&lt; 0 , 0 , 4 , 210 &gt;&gt; ) { % XDR.Int { datum : 1234 } , &lt;&lt; &gt;&gt; } More examples here . XDR.UInt - Unsigned Integer An XDR unsigned integer is a 32-bit datum that encodes a non-negative integer in the range [0, 4_294_967_295] . Encoding: iex(1)&gt; XDR.UInt . new ( 564 ) |&gt; XDR.UInt . encode_xdr ( ) { :ok , &lt;&lt; 0 , 0 , 2 , 52 &gt;&gt; } iex(1)&gt; XDR.UInt . new ( 564 ) |&gt; XDR.UInt . encode_xdr! ( ) &lt;&lt; 0 , 0 , 2 , 52 &gt;&gt; Decoding: iex(1)&gt; XDR.UInt . decode_xdr ( &lt;&lt; 0 , 0 , 2 , 52 &gt;&gt; ) { :ok , { % XDR.UInt { datum : 564 } , &lt;&lt; &gt;&gt; } } iex(1)&gt; XDR.UInt . decode_xdr! ( &lt;&lt; 0 , 0 , 2 , 52 &gt;&gt; ) { % XDR.UInt { datum : 564 } , &lt;&lt; &gt;&gt; } More examples here . XDR.Enum - Enumeration Represents subsets of integers. The Enumeration's declarations are a keyword list of integers (E.g. [false: 0, true: 1] ). Encoding: iex(1)&gt; XDR.Enum . new ( [ false : 0 , true : 1 ] , :false ) |&gt; XDR.Enum . encode_xdr ( ) { :ok , &lt;&lt; 0 , 0 , 0 , 0 &gt;&gt; } iex(1)&gt; XDR.Enum . new ( [ false : 0 , true : 1 ] , :true ) |&gt; XDR.Enum . encode_xdr! ( ) &lt;&lt; 0 , 0 , 0 , 1 &gt;&gt; Decoding: iex(1)&gt; enum_spec = XDR.Enum . new ( [ false : 0 , true : 1 ] , nil ) iex(2)&gt; XDR.Enum . decode_xdr ( &lt;&lt; 0 , 0 , 0 , 1 &gt;&gt; , enum_spec ) { :ok , { % XDR.Enum { declarations : [ false : 0 , true : 1 ] , identifier : true } , &lt;&lt; &gt;&gt; } } iex(1)&gt; XDR.Enum . decode_xdr! ( &lt;&lt; 0 , 0 , 0 , 0 &gt;&gt; , %{ declarations : [ false : 0 , true : 1 ] } ) { % XDR.Enum { declarations : [ false : 0 , true : 1 ] , identifier : false } , &lt;&lt; &gt;&gt; } More examples here . XDR.Bool - Boolean Boolean is an Enumeration implementation that allows us to create boolean types. An XDR Boolean type is an Enumeration with the keyword list [false: 0, true: 1] as declarations. Encoding: iex(1)&gt; XDR.Bool . new ( true ) |&gt; XDR.Bool . encode_xdr ( ) { :ok , &lt;&lt; 0 , 0 , 0 , 0 &gt;&gt; } iex(1)&gt; XDR.Bool . new ( true ) |&gt; XDR.Bool . encode_xdr! ( ) &lt;&lt; 0 , 0 , 0 , 0 &gt;&gt; Decoding: iex(1)&gt; XDR.Bool . decode_xdr ( &lt;&lt; 0 , 0 , 0 , 1 &gt;&gt; ) { :ok , { % XDR.Bool { declarations : [ false : 0 , true : 1 ] , identifier : true } , &quot;&quot; } } iex(1)&gt; XDR.Bool . decode_xdr! ( &lt;&lt; 0 , 0 , 0 , 1 &gt;&gt; ) { % XDR.Bool { declarations : [ false : 0 , true : 1 ] , identifier : true } , &quot;&quot; } More examples here . XDR.HyperInt - Hyper Integer It is an extension of the Integer type defined above. Represents a 64-bit (8-byte) integer with values in a range of [-9_223_372_036_854_775_808, 9_223_372_036_854_775_807] . Encoding: iex(1)&gt; XDR.HyperInt . new ( 9_223_372_036_854_775_807 ) |&gt; XDR.HyperInt . encode_xdr ( ) { :ok , &lt;&lt; 127 , 255 , 255 , 255 , 255 , 255 , 255 , 255 &gt;&gt; } iex(1)&gt; XDR.HyperInt . new ( 258963 ) |&gt; XDR.HyperInt . encode_xdr! ( ) &lt;&lt; 0 , 0 , 0 , 0 , 0 , 3 , 243 , 147 &gt;&gt; Decoding: iex(1)&gt; XDR.HyperInt . decode_xdr ( &lt;&lt; 0 , 0 , 0 , 0 , 0 , 3 , 243 , 147 &gt;&gt; ) { :ok , { % XDR.HyperInt { datum : 258963 } , &lt;&lt; &gt;&gt; } } iex(1)&gt; XDR.HyperInt . decode_xdr! ( &lt;&lt; 127 , 255 , 255 , 255 , 255 , 255 , 255 , 255 &gt;&gt; ) { % XDR.HyperInt { datum : 9223372036854775807 } , &lt;&lt; &gt;&gt; } More examples here . XDR.HyperUInt - Unsigned Hyper Integer It is an extension of the Unsigned Integer type defined above. Represents a 64-bit (8-byte) unsigned integer with values in a range of [0, 18_446_744_073_709_551_615] . Encoding: iex(1)&gt; XDR.HyperUInt . new ( 258963 ) |&gt; XDR.HyperUInt . encode_xdr ( ) { :ok , &lt;&lt; 0 , 0 , 0 , 0 , 0 , 3 , 243 , 147 &gt;&gt; } iex(1)&gt; XDR.HyperUInt . new ( 18_446_744_073_709_551_615 ) |&gt; XDR.HyperUInt . encode_xdr! ( ) &lt;&lt; 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 &gt;&gt; Decoding: iex(1)&gt; XDR.HyperUInt . decode_xdr ( &lt;&lt; 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 &gt;&gt; ) { :ok , { % XDR.HyperUInt { datum : 18446744073709551615 } , &lt;&lt; &gt;&gt; } } iex(1)&gt; XDR.HyperUInt . decode_xdr! ( &lt;&lt; 0 , 0 , 0 , 0 , 0 , 3 , 243 , 147 &gt;&gt; ) { % XDR.HyperUInt { datum : 258963 } , &lt;&lt; &gt;&gt; } More examples here . XDR.Float - Floating Point Represents a single-precision float value (32 bits, 4 bytes). Encoding: iex(1)&gt; XDR.Float . new ( 3.46 ) |&gt; XDR.Float . encode_xdr ( ) { :ok , &lt;&lt; 64 , 93 , 112 , 164 &gt;&gt; } iex(1)&gt; XDR.Float . new ( - 2589 ) |&gt; XDR.Float . encode_xdr! ( ) &lt;&lt; 197 , 33 , 208 , 0 &gt;&gt; Decoding: iex(1)&gt; XDR.Float . decode_xdr ( &lt;&lt; 64 , 93 , 112 , 164 &gt;&gt; ) { :ok , { % XDR.Float { float : 3.4600000381469727 } , &lt;&lt; &gt;&gt; } } iex(1)&gt; XDR.Float . decode_xdr! ( &lt;&lt; 197 , 33 , 208 , 0 &gt;&gt; ) { % XDR.Float { float : - 2589.0 } , &lt;&lt; &gt;&gt; } More examples here . XDR.DoubleFloat - Double-Floating Point Represents a Double-precision float value (64 bits, 8 bytes). Encoding: iex(1)&gt; XDR.DoubleFloat . new ( 0.333333333333333314829616256247390992939472198486328125 ) |&gt; XDR.DoubleFloat . encode_xdr ( ) { :ok , &lt;&lt; 63 , 213 , 85 , 85 , 85 , 85 , 85 , 85 &gt;&gt; } iex(1)&gt; XDR.DoubleFloat . new ( 258963 ) |&gt; XDR.DoubleFloat . encode_xdr! ( ) &lt;&lt; 65 , 15 , 156 , 152 , 0 , 0 , 0 , 0 &gt;&gt; Decoding: iex(1)&gt; XDR.DoubleFloat . decode_xdr ( &lt;&lt; 65 , 15 , 156 , 152 , 0 , 0 , 0 , 0 &gt;&gt; ) { :ok , { % XDR.DoubleFloat { float : 258963.0 } , &quot;&quot; } } iex(1)&gt; XDR.DoubleFloat . decode_xdr! ( &lt;&lt; 64 , 11 , 174 , 20 , 122 , 225 , 71 , 174 &gt;&gt; ) { % XDR.DoubleFloat { float : 3.46 } , &lt;&lt; &gt;&gt; } More examples here . XDR.FixedOpaque - Fixed-Length Opaque Represents a fixed-length uninterpreted data (This data is called &quot;opaque&quot;) that needs to be passed among machines. In the following examples we will use an opaque of 12-bytes length: Encoding: iex(1)&gt; XDR.FixedOpaque . new ( &lt;&lt; 72 , 101 , 108 , 108 , 111 , 32 , 119 , 111 , 114 , 108 , 100 , 0 &gt;&gt; , 12 ) |&gt; XDR.FixedOpaque . encode_xdr ( ) { :ok , &lt;&lt; 72 , 101 , 108 , 108 , 111 , 32 , 119 , 111 , 114 , 108 , 100 , 0 &gt;&gt; } iex(1)&gt; XDR.FixedOpaque . new ( &lt;&lt; 72 , 101 , 108 , 108 , 111 , 32 , 119 , 111 , 114 , 108 , 100 , 0 &gt;&gt; , 12 ) |&gt; XDR.FixedOpaque . encode_xdr! ( ) &lt;&lt; 72 , 101 , 108 , 108 , 111 , 32 , 119 , 111 , 114 , 108 , 100 , 0 &gt;&gt; Decoding: iex(1)&gt; XDR.FixedOpaque . decode_xdr ( &lt;&lt; 72 , 101 , 108 , 108 , 111 , 32 , 119 , 111 , 114 , 108 , 100 , 0 &gt;&gt; , %{ length : 12 } ) { :ok , { % XDR.FixedOpaque { length : 12 , opaque : &lt;&lt; 72 , 101 , 108 , 108 , 111 , 32 , 119 , 111 , 114 , 108 , 100 , 0 &gt;&gt; } , &quot;&quot; } } iex(1)&gt; opaque_spec = XDR.FixedOpaque . new ( nil , 12 ) iex(2)&gt; XDR.FixedOpaque . decode_xdr! ( &lt;&lt; 72 , 101 , 108 , 108 , 111 , 32 , 119 , 111 , 114 , 108 , 100 , 0 &gt;&gt; , opaque_spec ) { % XDR.FixedOpaque { length : 12 , opaque : &lt;&lt; 72 , 101 , 108 , 108 , 111 , 32 , 119 , 111 , 114 , 108 , 100 , 0 &gt;&gt; } , &quot;&quot; } More examples here . XDR.VariableOpaque - Variable-Length Opaque Represents a sequence of n (numbered 0 through n-1) arbitrary bytes to be the number n encoded as an unsigned integer. If the maximum length is not specified, it is assumed to be 2&lt;sup&gt;32&lt;/sup&gt; - 1. Encoding: iex(1)&gt; XDR.VariableOpaque . new ( &lt;&lt; 1 , 2 , 3 , 4 , 5 &gt;&gt; , 5 ) |&gt; XDR.VariableOpaque . encode_xdr ( ) { :ok , &lt;&lt; 0 , 0 , 0 , 5 , 1 , 2 , 3 , 4 , 5 , 0 , 0 , 0 &gt;&gt; } iex(1)&gt; XDR.VariableOpaque . new ( &lt;&lt; 1 , 2 , 3 &gt;&gt; , 3 ) |&gt; XDR.VariableOpaque . encode_xdr! ( ) &lt;&lt; 0 , 0 , 0 , 3 , 1 , 2 , 3 , 0 &gt;&gt; Decoding: iex(1)&gt; XDR.VariableOpaque . decode_xdr ( &lt;&lt; 0 , 0 , 0 , 5 , 1 , 2 , 3 , 4 , 5 , 0 , 0 , 0 &gt;&gt; , %{ max_size : 5 } ) { :ok , { % XDR.VariableOpaque { max_size : 5 , opaque : &lt;&lt; 1 , 2 , 3 , 4 , 5 &gt;&gt; } , &lt;&lt; &gt;&gt; } } iex(1)&gt; XDR.VariableOpaque . decode_xdr! ( &lt;&lt; 0 , 0 , 0 , 5 , 1 , 2 , 3 , 4 , 5 , 0 , 0 , 0 &gt;&gt; , %{ max_size : 5 } ) { % XDR.VariableOpaque { max_size : 5 , opaque : &lt;&lt; 1 , 2 , 3 , 4 , 5 &gt;&gt; } , &lt;&lt; &gt;&gt; } More examples here . XDR.String - String Represents a string of n (numbered 0 through n-1) ASCII bytes to be the number n encoded as an unsigned integer (as described above), and followed by the n bytes of the string. If the maximum length is not specified, it is assumed to be 2&lt;sup&gt;32&lt;/sup&gt; - 1. Encoding: iex(1)&gt; XDR.String . new ( &quot;The little prince&quot; ) |&gt; XDR.String . encode_xdr ( ) { :ok , &lt;&lt; 0 , 0 , 0 , 17 , 84 , 104 , 101 , 32 , 108 , 105 , 116 , 116 , 108 , 101 , 32 , 112 , 114 , 105 , 110 , 99 , 101 , 0 , 0 , 0 &gt;&gt; } iex(1)&gt; XDR.String . new ( &quot;The little prince&quot; ) |&gt; XDR.String . encode_xdr! ( ) &lt;&lt; 0 , 0 , 0 , 17 , 84 , 104 , 101 , 32 , 108 , 105 , 116 , 116 , 108 , 101 , 32 , 112 , 114 , 105 , 110 , 99 , 101 , 0 , 0 , 0 &gt;&gt; Decoding: iex(1)&gt; XDR.String . decode_xdr ( &lt;&lt; 0 , 0 , 0 , 17 , 84 , 104 , 101 , 32 , 108 , 105 , 116 , 116 , 108 , 101 , 32 , 112 , 114 , 105 , 110 , 99 , 101 , 0 , 0 , 0 &gt;&gt; ) { :ok , { % XDR.String { max_length : 4294967295 , string : &quot;The little prince&quot; } , &quot;&quot; } } iex(1)&gt; XDR.String . decode_xdr! ( &lt;&lt; 0 , 0 , 0 , 17 , 84 , 104 , 101 , 32 , 108 , 105 , 116 , 116 , 108 , 101 , 32 , 112 , 114 , 105 , 110 , 99 , 101 , 0 , 0 , 0 &gt;&gt; ) { % XDR.String { max_length : 4294967295 , string : &quot;The little prince&quot; } , &quot;&quot; } More examples here . XDR.FixedArray - Fixed-Length Array Represents a fixed-length array that contains elements with the same type. Encoding: iex(1)&gt; XDR.FixedArray . new ( [ 1 , 2 , 3 ] , XDR.Int , 3 ) |&gt; XDR.FixedArray . encode_xdr ( ) { :ok , &lt;&lt; 0 , 0 , 0 , 1 , 0 , 0 , 0 , 2 , 0 , 0 , 0 , 3 &gt;&gt; } iex(1)&gt; XDR.FixedArray . new ( [ &quot;The&quot; , &quot;little&quot; , &quot;prince&quot; ] , XDR.String , 3 ) |&gt; XDR.FixedArray . encode_xdr! ( ) &lt;&lt; 0 , 0 , 0 , 3 , 84 , 104 , 101 , 0 , 0 , 0 , 0 , 6 , 108 , 105 , 116 , 116 , 108 , 101 , 0 , 0 , 0 , 0 , 0 , 6 , 112 , 114 , 105 , 110 , 99 , 101 , 0 , 0 &gt;&gt; Decoding: iex(1)&gt; XDR.FixedArray . decode_xdr ( &lt;&lt; 0 , 0 , 0 , 1 , 0 , 0 , 0 , 2 , 0 , 0 , 0 , 3 &gt;&gt; , %{ type : XDR.Int , length : 3 } ) { :ok , { [ % XDR.Int { datum : 1 } , % XDR.Int { datum : 2 } , % XDR.Int { datum : 3 } ] , &lt;&lt; &gt;&gt; } } iex(1)&gt; XDR.FixedArray . decode_xdr! ( &lt;&lt; 0 , 0 , 0 , 3 , 84 , 104 , 101 , 0 , 0 , 0 , 0 , 6 , 108 , 105 , 116 , 116 , 108 , 101 , 0 , 0 , 0 , 0 , 0 , 6 , 112 , 114 , 105 , 110 , 99 , 101 , 0 , 0 &gt;&gt; , %{ type : XDR.String , length : 3 } ) { [ % XDR.String { max_length : 4294967295 , string : &quot;The&quot; } , % XDR.String { max_length : 4294967295 , string : &quot;little&quot; } , % XDR.String { max_length : 4294967295 , string : &quot;prince&quot; } ] , &lt;&lt; &gt;&gt; } More examples here . XDR.VariableArray - Variable-Length Array Represents a variable-length array that contains elements with the same type. If the maximum length is not specified, it is assumed to be 2&lt;sup&gt;32&lt;/sup&gt; - 1. Encoding: iex(1)&gt; XDR.VariableArray . new ( [ 1 , 2 , 3 ] , XDR.Int ) |&gt; XDR.VariableArray . encode_xdr ( ) { :ok , &lt;&lt; 0 , 0 , 0 , 3 , 0 , 0 , 0 , 1 , 0 , 0 , 0 , 2 , 0 , 0 , 0 , 3 &gt;&gt; } iex(1)&gt; XDR.VariableArray . new ( [ &quot;The&quot; , &quot;little&quot; , &quot;prince&quot; ] , XDR.String ) |&gt; XDR.VariableArray . encode_xdr! ( ) &lt;&lt; 0 , 0 , 0 , 3 , 0 , 0 , 0 , 3 , 84 , 104 , 101 , 0 , 0 , 0 , 0 , 6 , 108 , 105 , 116 , 116 , 108 , 101 , 0 , 0 , 0 , 0 , 0 , 6 , 112 , 114 , 105 , 110 , 99 , 101 , 0 , 0 &gt;&gt; Decoding: iex(1)&gt; XDR.VariableArray . decode_xdr ( &lt;&lt; 0 , 0 , 0 , 3 , 0 , 0 , 0 , 1 , 0 , 0 , 0 , 2 , 0 , 0 , 0 , 3 &gt;&gt; , ...&gt; %{ type : XDR.Int , max_length : 3 } ) { :ok , { [ % XDR.Int { datum : 1 } , % XDR.Int { datum : 2 } , % XDR.Int { datum : 3 } ] , &lt;&lt; &gt;&gt; } } iex(1)&gt; XDR.VariableArray . decode_xdr! ( &lt;&lt; 0 , 0 , 0 , 3 , 0 , 0 , 0 , 3 , 84 , 104 , 101 , 0 , 0 , 0 , 0 , 6 , 108 , 105 , ...&gt; 116 , 116 , 108 , 101 , 0 , 0 , 0 , 0 , 0 , 6 , 112 , 114 , 105 , 110 , 99 , 101 , 0 , 0 &gt;&gt; , ...&gt; %{ type : XDR.String , length : 3 } ) { [ % XDR.String { max_length : 4294967295 , string : &quot;The&quot; } , % XDR.String { max_length : 4294967295 , string : &quot;little&quot; } , % XDR.String { max_length : 4294967295 , string : &quot;prince&quot; } ] , &lt;&lt; &gt;&gt; } More examples here . XDR.Struct - Structure Represents a collection of fields, possibly of different data types, typically in fixed and sequence numbers. Encoding: iex(1)&gt; name = XDR.String . new ( &quot;The little prince&quot; ) % XDR.String { max_length : 4294967295 , string : &quot;The little prince&quot; } iex(2)&gt; size = XDR.Int . new ( 298 ) % XDR.Int { datum : 298 } iex(3)&gt; Struct . new ( [ name : name , size : size ] ) |&gt; Struct . encode_xdr ( ) { :ok , &lt;&lt; 0 , 0 , 0 , 17 , 84 , 104 , 101 , 32 , 108 , 105 , 116 , 116 , 108 , 101 , 32 , 112 , 114 , 105 , 110 , 99 , 101 , 0 , 0 , 0 , 0 , 0 , 1 , 42 &gt;&gt; } iex(1)&gt; name = XDR.String . new ( &quot;The little prince&quot; ) % XDR.String { max_length : 4294967295 , string : &quot;The little prince&quot; } iex(2)&gt; size = XDR.Int . new ( 298 ) % XDR.Int { datum : 298 } iex(3)&gt; XDR.Struct . new ( [ name : name , size : size ] ) |&gt; XDR.Struct . encode_xdr! ( ) &lt;&lt; 0 , 0 , 0 , 17 , 84 , 104 , 101 , 32 , 108 , 105 , 116 , 116 , 108 , 101 , 32 , 112 , 114 , 105 , 110 , 99 , 101 , 0 , 0 , 0 , 0 , 0 , 1 , 42 &gt;&gt; Decoding: iex(1)&gt; struct_spec = XDR.Struct . new ( [ name : XDR.String , size : XDR.Int ] ) iex(2)&gt; XDR.Struct . decode_xdr ( &lt;&lt; 0 , 0 , 0 , 17 , 84 , 104 , 101 , 32 , 108 , 105 , 116 , 116 , 108 , 101 , 32 , 112 , 114 , 105 , 110 , 99 , 101 , 0 , 0 , 0 , 0 , 0 , 1 , 42 &gt;&gt; , struct_spec ) { :ok , { % XDR.Struct { components : [ name : % XDR.String { max_length : 4294967295 , string : &quot;The little prince&quot; } , size : % XDR.Int { datum : 298 } ] } , &quot;&quot; } } iex(1)&gt; struct_spec = XDR.Struct . new ( [ name : XDR.String , size : XDR.Int ] ) iex(2)&gt; XDR.Struct . decode_xdr! ( &lt;&lt; 0 , 0 , 0 , 17 , 84 , 104 , 101 , 32 , 108 , 105 , 116 , 116 , 108 , 101 , 32 , 112 , 114 , 105 , 110 , 99 , 101 , 0 , 0 , 0 , 0 , 0 , 1 , 42 &gt;&gt; , struct_spec ) { % XDR.Struct { components : [ name : % XDR.String { max_length : 4294967295 , string : &quot;The little prince&quot; } , size : % XDR.Int { datum : 298 } ] } , &quot;&quot; } More examples here . XDR.Union - Discriminated Union A discriminated union is a type composed of a discriminant followed by a type selected from a set of prearranged types according to the value of the discriminant. The component types are called arms of the union and are preceded by the value of the discriminant that implies their encoding or decoding. The type of discriminant is either XDR.Int , XDR.UInt , or an XDR.Enum type. The arms can be a keyword list or a map and the value of each arm can be either a struct or a module of any XDR type. You can define a default arm using :default as a key (The default arm is optional). Encoding: iex(1)&gt; enum = % XDR.Enum { declarations : [ case_1 : 1 , case_2 : 2 , case_3 : 3 ] , identifier : :case_1 } iex(2)&gt; arms = [ case_1 : % XDR.Int { datum : 123 } , case_2 : % XDR.Int { datum : 2 } , case_3 : XDR.Float , default : XDR.String ] iex(3)&gt; enum |&gt; XDR.Union . new ( arms ) |&gt; XDR.Union . encode_xdr ( ) { :ok , &lt;&lt; 0 , 0 , 0 , 1 , 0 , 0 , 0 , 123 &gt;&gt; } Decoding: iex(1)&gt; enum = % XDR.Enum { declarations : [ case_1 : 1 , case_2 : 2 , case_3 : 3 ] } iex(2)&gt; arms = [ case_1 : % XDR.Int { datum : 123 } , case_2 : % XDR.Int { datum : 2 } , case_3 : XDR.Float , default : XDR.String ] iex(3)&gt; union = XDR.Union . new ( enum , arms ) iex(4)&gt; XDR.Union . decode_xdr ( &lt;&lt; 0 , 0 , 0 , 1 , 0 , 0 , 0 , 123 &gt;&gt; , union ) { :ok , { { :case_1 , % XDR.Int { datum : 123 } } , &quot;&quot; } } More examples here . XDR.Void - Void Represents a 0-byte quantity. Encoding: iex(1)&gt; XDR.Void . new ( nil ) |&gt; XDR.Void . encode_xdr ( ) { :ok , &lt;&lt; &gt;&gt; } iex(1)&gt; XDR.Void . new ( ) |&gt; XDR.Void . encode_xdr! ( ) &lt;&lt; &gt;&gt; Decoding: iex(1)&gt; XDR.Void . decode_xdr ( &lt;&lt; &gt;&gt; ) { :ok , { nil , &lt;&lt; &gt;&gt; } } iex(1)&gt; XDR.Void . decode_xdr! ( &lt;&lt; 72 , 101 , 108 , 108 , 111 &gt;&gt; ) { nil , &lt;&lt; 72 , 101 , 108 , 108 , 111 , 0 &gt;&gt; } More examples here . XDR.Optional - Optional Represents one kind of union that occurs so frequently that we give it a special syntax of its own for declaring it. An optional-data could be any XDR type of data or XDR.Void . Encoding: iex(1)&gt; XDR.String . new ( &quot;this is an example.&quot; ) |&gt; XDR.Optional . new ( ) |&gt; XDR.Optional . encode_xdr ( ) { :ok , &lt;&lt; 0 , 0 , 0 , 1 , 0 , 0 , 0 , 19 , 116 , 104 , 105 , 115 , 32 , 105 , 115 , 32 , 97 , 110 , 32 , 101 , 120 , 97 , 109 , 112 , 108 , 101 , 46 , 0 &gt;&gt; } iex(1)&gt; XDR.Optional . new ( nil ) |&gt; XDR.Optional . encode_xdr! ( ) &lt;&lt; 0 , 0 , 0 , 0 &gt;&gt; Decoding: iex(1)&gt; optional_spec = XDR.Optional . new ( XDR.String ) iex(2)&gt; XDR.Optional . decode_xdr ( &lt;&lt; 0 , 0 , 0 , 1 , 0 , 0 , 0 , 19 , 116 , 104 , 105 , 115 , 32 , 105 , 115 , 32 , 97 , 110 , 32 , 101 , 120 , 97 , 109 , 112 , 108 , 101 , 46 , 0 &gt;&gt; , optional_spec ) { :ok , { % XDR.Optional { type : % XDR.String { max_length : 4294967295 , string : &quot;this is an example&quot; } } , &quot;&quot; } } iex(1)&gt; optional_spec = XDR.Optional . new ( XDR.String ) iex(2)&gt; XDR.Optional . decode_xdr! ( &lt;&lt; 0 , 0 , 0 , 0 &gt;&gt; , optional_spec ) { nil , &quot;&quot; } More examples here .","ref":"readme.html#basic-usage-examples","title":"Elixir XDR - Basic usage examples","type":"extras"},{"doc":"Install any Elixir version above 1.7. Compile dependencies: mix deps.get . Run tests: mix test .","ref":"readme.html#development","title":"Elixir XDR - Development","type":"extras"},{"doc":"We welcome everyone to contribute. Make sure you have read the CODE_OF_CONDUCT before.","ref":"readme.html#code-of-conduct","title":"Elixir XDR - Code of conduct","type":"extras"},{"doc":"For information on how to contribute, please refer to our CONTRIBUTING guide.","ref":"readme.html#contributing","title":"Elixir XDR - Contributing","type":"extras"},{"doc":"Features and bug fixes are listed in the CHANGELOG file.","ref":"readme.html#changelog","title":"Elixir XDR - Changelog","type":"extras"},{"doc":"This library is licensed under an MIT license. See LICENSE for details.","ref":"readme.html#license","title":"Elixir XDR - License","type":"extras"},{"doc":"Made with 💙 by kommitters Open Source","ref":"readme.html#acknowledgements","title":"Elixir XDR - Acknowledgements","type":"extras"},{"doc":"Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Add security policy to the repository","ref":"changelog.html#0-3-1-25-07-2022","title":"Changelog - 0.3.1 (25.07.2022)","type":"extras"},{"doc":"Automate publishing releases","ref":"changelog.html#0-3-0-19-07-2022","title":"Changelog - 0.3.0 (19.07.2022)","type":"extras"},{"doc":"Fix array's elements encoding bug. Refactor library exceptions. Credo integration. Code cleanup.","ref":"changelog.html#0-2-0-27-08-2021","title":"Changelog - 0.2.0 (27.08.2021)","type":"extras"},{"doc":"Solve success-typing dialyzer warnings. Properly define typespecs. Remove compilation warnings from old dependencies. Improve library documentation.","ref":"changelog.html#0-1-6-25-08-2021","title":"Changelog - 0.1.6 (25.08.2021)","type":"extras"},{"doc":"Fix max length issue on Strings. Fix issues encoding/decoding discriminated unions.","ref":"changelog.html#0-1-5-09-08-2021","title":"Changelog - 0.1.5 (09.08.2021)","type":"extras"},{"doc":"Improve README. Improve documentation of all the XDR types for Hexdocs. Added custom implementations of all the XDR types to examples for Hexdocs. Improve functions specs for all the XDR types. Improve Discriminated Union allowing add module as arm type. Add Discriminated Union with :default arm. Improve Void allowing return remaining binary after decoding. Fix maximum default length set to Variable-Length Array. Add some unit tests. Improve the documentation and some implementations of all XDR types modules.","ref":"changelog.html#0-1-4-30-06-2020","title":"Changelog - 0.1.4 (30.06.2020)","type":"extras"},{"doc":"Increase test coverage to 100% The encode_xdr() and decode_xdr() functions now return error tuples The encode_xdr!() and decode_xdr!() functions raise the errors Add examples of all the XDR-types to README Add examples to Hexdocs Remove Anti-Patterns","ref":"changelog.html#0-1-3-22-05-2020","title":"Changelog - 0.1.3 (22.05.2020)","type":"extras"},{"doc":"Add support for older Elixir versions strating from 1.7.0. Setup ExCoveralls and Credo for code quality. Improve readme file. Add project badges.","ref":"changelog.html#0-1-2-18-05-2020","title":"Changelog - 0.1.2 (18.05.2020)","type":"extras"},{"doc":"Initial release","ref":"changelog.html#0-1-1-15-05-2020","title":"Changelog - 0.1.1 (15.05.2020)","type":"extras"},{"doc":"XDR.Int - Integer An XDR signed integer is a 32-bit datum that encodes an integer in the range [-2_147_483_648, 2_147_483_647] . Integer - RFC 4506","ref":"integer.html","title":"XDR.Int - Integer","type":"extras"},{"doc":"Encoding iex(1)&gt; XDR.Int . new ( 564 ) |&gt; XDR.Int . encode_xdr ( ) { :ok , &lt;&lt; 0 , 0 , 2 , 52 &gt;&gt; } iex(1)&gt; XDR.Int . new ( 564 ) |&gt; XDR.Int . encode_xdr! ( ) &lt;&lt; 0 , 0 , 2 , 52 &gt;&gt; Decoding iex(1)&gt; XDR.Int . decode_xdr ( &lt;&lt; 0 , 0 , 2 , 52 &gt;&gt; ) { :ok , { % XDR.Int { datum : 564 } , &lt;&lt; &gt;&gt; } } iex(1)&gt; XDR.Int . decode_xdr! ( &lt;&lt; 0 , 0 , 2 , 52 &gt;&gt; ) { % XDR.Int { datum : 564 } , &lt;&lt; &gt;&gt; } Custom Integer example defmodule CustomInt do @type t :: XDR.Int . t ( ) defdelegate new ( num ) , to : XDR.Int defdelegate encode_xdr ( int ) , to : XDR.Int defdelegate encode_xdr! ( int ) , to : XDR.Int defdelegate decode_xdr ( bytes ) , to : XDR.Int defdelegate decode_xdr! ( bytes ) , to : XDR.Int end # Encode CustomInt . new ( 123 ) |&gt; CustomInt . encode_xdr ( ) # Decode CustomInt . decode_xdr! ( &lt;&lt; 0 , 0 , 2 , 52 &gt;&gt; )","ref":"integer.html#usage","title":"XDR.Int - Integer - Usage","type":"extras"},{"doc":"XDR.UInt - Unsigned Integer Represents integer values in the range [0, 4_294_967_295] . Unsigned Integer - RFC 4506","ref":"unsigned_integer.html","title":"XDR.UInt - Unsigned Integer","type":"extras"},{"doc":"Encoding iex(1)&gt; XDR.UInt . new ( 564 ) |&gt; XDR.UInt . encode_xdr ( ) { :ok , &lt;&lt; 0 , 0 , 2 , 52 &gt;&gt; } iex(1)&gt; XDR.UInt . new ( 564 ) |&gt; XDR.UInt . encode_xdr! ( ) &lt;&lt; 0 , 0 , 2 , 52 &gt;&gt; Decoding iex(1)&gt; XDR.UInt . decode_xdr ( &lt;&lt; 0 , 0 , 2 , 52 &gt;&gt; ) { :ok , { % XDR.UInt { datum : 564 } , &lt;&lt; &gt;&gt; } } iex(1)&gt; XDR.UInt . decode_xdr! ( &lt;&lt; 0 , 0 , 2 , 52 &gt;&gt; ) { % XDR.UInt { datum : 564 } , &lt;&lt; &gt;&gt; } Custom Unsigned Integer example defmodule CustomUInt do @type t :: XDR.UInt . t ( ) defdelegate new ( num ) , to : XDR.UInt defdelegate encode_xdr ( uint ) , to : XDR.UInt defdelegate encode_xdr! ( uint ) , to : XDR.UInt defdelegate decode_xdr ( bytes ) , to : XDR.UInt defdelegate decode_xdr! ( bytes ) , to : XDR.UInt end # Encode CustomUInt . new ( 123 ) |&gt; CustomUInt . encode_xdr ( ) # Decode CustomUInt . decode_xdr! ( &lt;&lt; 0 , 0 , 2 , 52 &gt;&gt; )","ref":"unsigned_integer.html#usage","title":"XDR.UInt - Unsigned Integer - Usage","type":"extras"},{"doc":"XDR.Enum - Enumeration Represents subsets of integers. The Enumeration's declarations is a keyword list of integers (E.g. [false: 0, true: 1] ). Enumeration - RFC 4506","ref":"enumeration.html","title":"XDR.Enum - Enumeration","type":"extras"},{"doc":"To implement an Enumeration type, we need to define the declarations as a keyword list that contains the possible values to select in each key.","ref":"enumeration.html#implementation","title":"XDR.Enum - Enumeration - Implementation","type":"extras"},{"doc":"Encoding iex(1)&gt; XDR.Enum . new ( [ false : 0 , true : 1 ] , :false ) |&gt; XDR.Enum . encode_xdr ( ) { :ok , &lt;&lt; 0 , 0 , 0 , 0 &gt;&gt; } iex(1)&gt; XDR.Enum . new ( [ false : 0 , true : 1 ] , :true ) |&gt; XDR.Enum . encode_xdr! ( ) &lt;&lt; 0 , 0 , 0 , 1 &gt;&gt; Decoding iex(1)&gt; enum_spec = XDR.Enum . new ( [ false : 0 , true : 1 ] , nil ) iex(2)&gt; XDR.Enum . decode_xdr ( &lt;&lt; 0 , 0 , 0 , 1 &gt;&gt; , enum_spec ) { :ok , { % XDR.Enum { declarations : [ false : 0 , true : 1 ] , identifier : true } , &lt;&lt; &gt;&gt; } } iex(1)&gt; XDR.Enum . decode_xdr! ( &lt;&lt; 0 , 0 , 0 , 0 &gt;&gt; , %{ declarations : [ false : 0 , true : 1 ] } ) { % XDR.Enum { declarations : [ false : 0 , true : 1 ] , identifier : false } , &lt;&lt; &gt;&gt; } Custom Enumeration example defmodule CustomEnum do @declarations [ type_1 : 1 , type_2 : 2 , type_3 : 3 ] @type t :: XDR.Enum . t ( ) @spec new ( identifier :: atom ( ) ) :: t def new ( identifier \\\\ nil ) , do : XDR.Enum . new ( @declarations , identifier ) defdelegate encode_xdr ( custom_enum ) , to : XDR.Enum defdelegate encode_xdr! ( custom_enum ) , to : XDR.Enum defdelegate decode_xdr ( bytes , custom_enum \\\\ new ( ) ) , to : XDR.Enum defdelegate decode_xdr! ( bytes , custom_enum \\\\ new ( ) ) , to : XDR.Enum end # Encode CustomEnum . new ( :type_2 ) |&gt; CustomEnum . encode_xdr ( ) # Decode CustomEnum . decode_xdr! ( &lt;&lt; 0 , 0 , 0 , 2 &gt;&gt; )","ref":"enumeration.html#usage","title":"XDR.Enum - Enumeration - Usage","type":"extras"},{"doc":"XDR.Bool - Boolean Boolean is an Enumeration implementation that allows us to create boolean types. An XDR Boolean type is an Enumeration with the keyword list [false: 0, true: 1] as declarations. Boolean - RFC 4506","ref":"boolean.html","title":"XDR.Bool - Boolean","type":"extras"},{"doc":"Encoding iex(1)&gt; XDR.Bool . new ( true ) |&gt; XDR.Bool . encode_xdr ( ) { :ok , &lt;&lt; 0 , 0 , 0 , 0 &gt;&gt; } iex(1)&gt; XDR.Bool . new ( true ) |&gt; XDR.Bool . encode_xdr! ( ) &lt;&lt; 0 , 0 , 0 , 0 &gt;&gt; Decoding iex(1)&gt; XDR.Bool . decode_xdr ( &lt;&lt; 0 , 0 , 0 , 1 &gt;&gt; ) { :ok , { % XDR.Bool { declarations : [ false : 0 , true : 1 ] , identifier : true } , &quot;&quot; } } iex(1)&gt; XDR.Bool . decode_xdr! ( &lt;&lt; 0 , 0 , 0 , 1 &gt;&gt; ) { % XDR.Bool { declarations : [ false : 0 , true : 1 ] , identifier : true } , &quot;&quot; } Custom Boolean example defmodule CustomBoolean do @type t :: XDR.Bool . t ( ) defdelegate new ( bool_value ) , to : XDR.Bool defdelegate encode_xdr ( bool ) , to : XDR.Bool defdelegate encode_xdr! ( bool ) , to : XDR.Bool defdelegate decode_xdr ( bytes ) , to : XDR.Bool defdelegate decode_xdr! ( bytes ) , to : XDR.Bool end # Encode CustomBoolean . new ( true ) |&gt; CustomBoolean . encode_xdr ( ) # Decode CustomBoolean . decode_xdr ( &lt;&lt; 0 , 0 , 0 , 1 &gt;&gt; )","ref":"boolean.html#usage","title":"XDR.Bool - Boolean - Usage","type":"extras"},{"doc":"XDR.HyperInt - Hyper Integer It is an extension of the Integer type defined above. Represents a 64-bit (8-byte) integer with values in a range of [-9_223_372_036_854_775_808, 9_223_372_036_854_775_807] . Hyper Integer - RFC 4506","ref":"hyper_integer.html","title":"XDR.HyperInt - Hyper Integer","type":"extras"},{"doc":"Encoding iex(1)&gt; XDR.HyperInt . new ( 9_223_372_036_854_775_807 ) |&gt; XDR.HyperInt . encode_xdr ( ) { :ok , &lt;&lt; 127 , 255 , 255 , 255 , 255 , 255 , 255 , 255 &gt;&gt; } iex(1)&gt; XDR.HyperInt . new ( 258963 ) |&gt; XDR.HyperInt . encode_xdr! ( ) &lt;&lt; 0 , 0 , 0 , 0 , 0 , 3 , 243 , 147 &gt;&gt; Decoding iex(1)&gt; XDR.HyperInt . decode_xdr ( &lt;&lt; 0 , 0 , 0 , 0 , 0 , 3 , 243 , 147 &gt;&gt; ) { :ok , { % XDR.HyperInt { datum : 258963 } , &lt;&lt; &gt;&gt; } } iex(1)&gt; XDR.HyperInt . decode_xdr! ( &lt;&lt; 127 , 255 , 255 , 255 , 255 , 255 , 255 , 255 &gt;&gt; ) { % XDR.HyperInt { datum : 9223372036854775807 } , &lt;&lt; &gt;&gt; } Custom Hyper Integer defmodule CustomHyperInt do @type t :: XDR.HyperInt . t ( ) defdelegate new ( num ) , to : XDR.HyperInt defdelegate encode_xdr ( hyper_int ) , to : XDR.HyperInt defdelegate encode_xdr! ( hyper_int ) , to : XDR.HyperInt defdelegate decode_xdr ( bytes ) , to : XDR.HyperInt defdelegate decode_xdr! ( bytes ) , to : XDR.HyperInt end # Encode CustomHyperInt . new ( 123 ) |&gt; CustomHyperInt . encode_xdr ( ) # Decode CustomHyperInt . decode_xdr! ( &lt;&lt; 0 , 0 , 2 , 52 &gt;&gt; )","ref":"hyper_integer.html#usage","title":"XDR.HyperInt - Hyper Integer - Usage","type":"extras"},{"doc":"XDR.HyperUInt - Unsigned Hyper Integer It is an extension of the Unsigned Integer type defined above. Represents a 64-bit (8-byte) unsigned integer with values in a range of [0, 18_446_744_073_709_551_615] . Unsigned Hyper Integer - RFC 4506","ref":"unsigned_hyper_integer.html","title":"XDR.HyperUInt - Unsigned Hyper Integer","type":"extras"},{"doc":"Encoding iex(1)&gt; XDR.HyperUInt . new ( 258963 ) |&gt; XDR.HyperUInt . encode_xdr ( ) { :ok , &lt;&lt; 0 , 0 , 0 , 0 , 0 , 3 , 243 , 147 &gt;&gt; } iex(1)&gt; XDR.HyperUInt . new ( 18_446_744_073_709_551_615 ) |&gt; XDR.HyperUInt . encode_xdr! ( ) &lt;&lt; 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 &gt;&gt; Decoding iex(1)&gt; XDR.HyperUInt . decode_xdr ( &lt;&lt; 255 , 255 , 255 , 255 , 255 , 255 , 255 , 255 &gt;&gt; ) { :ok , { % XDR.HyperUInt { datum : 18446744073709551615 } , &lt;&lt; &gt;&gt; } } iex(1)&gt; XDR.HyperUInt . decode_xdr! ( &lt;&lt; 0 , 0 , 0 , 0 , 0 , 3 , 243 , 147 &gt;&gt; ) { % XDR.HyperUInt { datum : 258963 } , &lt;&lt; &gt;&gt; } Custom Unsigned Integer example defmodule CustomHyperUInt do @type t :: XDR.HyperHyperUInt . t ( ) defdelegate new ( num ) , to : XDR.HyperHyperUInt defdelegate encode_xdr ( hyper_uint ) , to : XDR.HyperHyperUInt defdelegate encode_xdr! ( hyper_uint ) , to : XDR.HyperHyperUInt defdelegate decode_xdr ( bytes ) , to : XDR.HyperHyperUInt defdelegate decode_xdr! ( bytes ) , to : XDR.HyperHyperUInt end # Encode CustomHyperUInt . new ( 123 ) |&gt; CustomHyperUInt . encode_xdr ( ) # Decode CustomHyperUInt . decode_xdr! ( &lt;&lt; 0 , 0 , 2 , 52 &gt;&gt; )","ref":"unsigned_hyper_integer.html#usage","title":"XDR.HyperUInt - Unsigned Hyper Integer - Usage","type":"extras"},{"doc":"XDR.Float - Floating-Point Represents a single-precision float value (32 bits, 4 bytes). Floating-Point - RFC 4506","ref":"floating_point.html","title":"XDR.Float - Floating-Point","type":"extras"},{"doc":"Encoding iex(1)&gt; XDR.Float . new ( 3.46 ) |&gt; XDR.Float . encode_xdr ( ) { :ok , &lt;&lt; 64 , 93 , 112 , 164 &gt;&gt; } iex(1)&gt; XDR.Float . new ( - 2589 ) |&gt; XDR.Float . encode_xdr! ( ) &lt;&lt; 197 , 33 , 208 , 0 &gt;&gt; Decoding iex(1)&gt; XDR.Float . decode_xdr ( &lt;&lt; 64 , 93 , 112 , 164 &gt;&gt; ) { :ok , { % XDR.Float { float : 3.4600000381469727 } , &lt;&lt; &gt;&gt; } } iex(1)&gt; XDR.Float . decode_xdr! ( &lt;&lt; 197 , 33 , 208 , 0 &gt;&gt; ) { % XDR.Float { float : - 2589.0 } , &lt;&lt; &gt;&gt; } Custom Floating-Point example defmodule CustomFloat do @type t :: XDR.Float . t ( ) defdelegate new ( num ) , to : XDR.Float defdelegate encode_xdr ( float ) , to : XDR.Float defdelegate encode_xdr! ( float ) , to : XDR.Float defdelegate decode_xdr ( bytes ) , to : XDR.Float defdelegate decode_xdr! ( bytes ) , to : XDR.Float end # Encode CustomFloat . new ( &lt;&lt; 1 , 2 , 3 , 4 , 5 , 6 , 7 , 8 , 9 , 10 &gt;&gt; ) |&gt; CustomFloat . encode_xdr ( ) # Decode CustomFloat . decode_xdr! ( &lt;&lt; 1 , 2 , 3 , 4 , 5 , 6 , 7 , 8 , 9 , 10 &gt;&gt; )","ref":"floating_point.html#usage","title":"XDR.Float - Floating-Point - Usage","type":"extras"},{"doc":"XDR.DoubleFloat - Double-Precision Floating-Point Represents a Double-precision float value (64 bits, 8 bytes). Double-Precision Floating-Point - RFC 4506","ref":"double_floating_point.html","title":"XDR.DoubleFloat - Double-Precision Floating-Point","type":"extras"},{"doc":"Encoding iex(1)&gt; XDR.DoubleFloat . new ( 0.333333333333333314829616256247390992939472198486328125 ) |&gt; XDR.DoubleFloat . encode_xdr ( ) { :ok , &lt;&lt; 63 , 213 , 85 , 85 , 85 , 85 , 85 , 85 &gt;&gt; } iex(1)&gt; XDR.DoubleFloat . new ( 258963 ) |&gt; XDR.DoubleFloat . encode_xdr! ( ) &lt;&lt; 65 , 15 , 156 , 152 , 0 , 0 , 0 , 0 &gt;&gt; Decoding iex(1)&gt; XDR.DoubleFloat . decode_xdr ( &lt;&lt; 65 , 15 , 156 , 152 , 0 , 0 , 0 , 0 &gt;&gt; ) { :ok , { % XDR.DoubleFloat { float : 258963.0 } , &quot;&quot; } } iex(1)&gt; XDR.DoubleFloat . decode_xdr! ( &lt;&lt; 64 , 11 , 174 , 20 , 122 , 225 , 71 , 174 &gt;&gt; ) { % XDR.DoubleFloat { float : 3.46 } , &lt;&lt; &gt;&gt; } Custom Double-Precision Floating-Point example defmodule CustomDoubleFloat do @type t :: XDR.DoubleFloat . t ( ) defdelegate new ( num ) , to : XDR.DoubleFloat defdelegate encode_xdr ( double_float ) , to : XDR.DoubleFloat defdelegate encode_xdr! ( double_float ) , to : XDR.DoubleFloat defdelegate decode_xdr ( bytes ) , to : XDR.DoubleFloat defdelegate decode_xdr! ( bytes ) , to : XDR.DoubleFloat end # Encode CustomDoubleFloat . new ( 123.999 ) |&gt; CustomDoubleFloat . encode_xdr ( ) # Decode CustomDoubleFloat . decode_xdr! ( &lt;&lt; 64 , 94 , 255 , 239 , 157 , 178 , 45 , 14 &gt;&gt; )","ref":"double_floating_point.html#usage","title":"XDR.DoubleFloat - Double-Precision Floating-Point - Usage","type":"extras"},{"doc":"XDR.FixedOpaque - Fixed-Length Opaque Data Represents a fixed-length uninterpreted data (This data is called &quot;opaque&quot;) that needs to be passed among machines. Fixed-Length Opaque Data - RFC 4506","ref":"fixed_length_opaque.html","title":"XDR.FixedOpaque - Fixed-Length Opaque Data","type":"extras"},{"doc":"In the following examples we will use an opaque of 12-bytes length: Encoding iex(1)&gt; XDR.FixedOpaque . new ( &lt;&lt; 72 , 101 , 108 , 108 , 111 , 32 , 119 , 111 , 114 , 108 , 100 , 0 &gt;&gt; , 12 ) |&gt; XDR.FixedOpaque . encode_xdr ( ) { :ok , &lt;&lt; 72 , 101 , 108 , 108 , 111 , 32 , 119 , 111 , 114 , 108 , 100 , 0 &gt;&gt; } iex(1)&gt; XDR.FixedOpaque . new ( &lt;&lt; 72 , 101 , 108 , 108 , 111 , 32 , 119 , 111 , 114 , 108 , 100 , 0 &gt;&gt; , 12 ) |&gt; XDR.FixedOpaque . encode_xdr! ( ) &lt;&lt; 72 , 101 , 108 , 108 , 111 , 32 , 119 , 111 , 114 , 108 , 100 , 0 &gt;&gt; Decoding iex(1)&gt; XDR.FixedOpaque . decode_xdr ( &lt;&lt; 72 , 101 , 108 , 108 , 111 , 32 , 119 , 111 , 114 , 108 , 100 , 0 &gt;&gt; , %{ length : 12 } ) { :ok , { % XDR.FixedOpaque { length : 12 , opaque : &lt;&lt; 72 , 101 , 108 , 108 , 111 , 32 , 119 , 111 , 114 , 108 , 100 , 0 &gt;&gt; } , &quot;&quot; } } iex ( 1 ) &gt; opaque_spec = XDR.FixedOpaque . new ( nil , 12 ) iex(2)&gt; XDR.FixedOpaque . decode_xdr! ( &lt;&lt; 72 , 101 , 108 , 108 , 111 , 32 , 119 , 111 , 114 , 108 , 100 , 0 &gt;&gt; , opaque_spec ) { % XDR.FixedOpaque { length : 12 , opaque : &lt;&lt; 72 , 101 , 108 , 108 , 111 , 32 , 119 , 111 , 114 , 108 , 100 , 0 &gt;&gt; } , &quot;&quot; } Custom Fixed-Length Opaque Data example defmodule CustomFixedOpaque do @length 10 @type t :: XDR.FixedOpaque . t ( ) @spec new ( opaque :: binary ( ) ) :: XDR.FixedOpaque . t ( ) def new ( opaque \\\\ nil ) , do : XDR.FixedOpaque . new ( opaque , @length ) defdelegate encode_xdr ( fixed_opaque ) , to : XDR.FixedOpaque defdelegate encode_xdr! ( fixed_opaque ) , to : XDR.FixedOpaque defdelegate decode_xdr ( bytes , fixed_opaque \\\\ new ( ) ) , to : XDR.FixedOpaque defdelegate decode_xdr! ( bytes , fixed_opaque \\\\ new ( ) ) , to : XDR.FixedOpaque end # Encode CustomFixedOpaque . new ( &lt;&lt; 1 , 2 , 3 , 4 , 5 , 6 , 7 , 8 , 9 , 10 &gt;&gt; ) |&gt; CustomFixedOpaque . encode_xdr ( ) # Decode CustomFixedOpaque . decode_xdr! ( &lt;&lt; 1 , 2 , 3 , 4 , 5 , 6 , 7 , 8 , 9 , 10 &gt;&gt; )","ref":"fixed_length_opaque.html#usage","title":"XDR.FixedOpaque - Fixed-Length Opaque Data - Usage","type":"extras"},{"doc":"XDR.VariableOpaque - Variable-Length Opaque Represents a sequence of n (numbered 0 through n-1) arbitrary bytes to be the number n encoded as an unsigned integer. If the maximum length is not specified, it is assumed to be 2&lt;sup&gt;32&lt;/sup&gt; - 1. Variable-Length Opaque - RFC 4506 Encoding iex(1)&gt; XDR.VariableOpaque . new ( &lt;&lt; 1 , 2 , 3 , 4 , 5 &gt;&gt; , 5 ) |&gt; XDR.VariableOpaque . encode_xdr ( ) { :ok , &lt;&lt; 0 , 0 , 0 , 5 , 1 , 2 , 3 , 4 , 5 , 0 , 0 , 0 &gt;&gt; } iex(1)&gt; XDR.VariableOpaque . new ( &lt;&lt; 1 , 2 , 3 &gt;&gt; , 3 ) |&gt; XDR.VariableOpaque . encode_xdr! ( ) &lt;&lt; 0 , 0 , 0 , 3 , 1 , 2 , 3 , 0 &gt;&gt; Decoding iex(1)&gt; XDR.VariableOpaque . decode_xdr ( &lt;&lt; 0 , 0 , 0 , 5 , 1 , 2 , 3 , 4 , 5 , 0 , 0 , 0 &gt;&gt; , %{ max_size : 5 } ) { :ok , { % XDR.VariableOpaque { max_size : 5 , opaque : &lt;&lt; 1 , 2 , 3 , 4 , 5 &gt;&gt; } , &lt;&lt; &gt;&gt; } } iex(1)&gt; XDR.VariableOpaque . decode_xdr! ( &lt;&lt; 0 , 0 , 0 , 5 , 1 , 2 , 3 , 4 , 5 , 0 , 0 , 0 &gt;&gt; , %{ max_size : 5 } ) { % XDR.VariableOpaque { max_size : 5 , opaque : &lt;&lt; 1 , 2 , 3 , 4 , 5 &gt;&gt; } , &lt;&lt; &gt;&gt; } Custom Variable-Length Opaque example defmodule CustomVariableOpaque do @type t :: XDR.VariableOpaque . t ( ) @max_size 64 @spec new ( opaque :: binary ( ) ) :: t def new ( opaque \\\\ nil , max_size \\\\ @max_size ) when max_size &lt;= @max_size do XDR.VariableOpaque . new ( opaque , max_size ) end defdelegate encode_xdr ( variable_opaque ) , to : XDR.VariableOpaque defdelegate encode_xdr! ( variable_opaque ) , to : XDR.VariableOpaque defdelegate decode_xdr ( bytes , variable_opaque \\\\ new ( ) ) , to : XDR.VariableOpaque defdelegate decode_xdr! ( bytes , variable_opaque \\\\ new ( ) ) , to : XDR.VariableOpaque end # Encode CustomVariableOpaque . new ( &lt;&lt; 1 , 2 , 3 , 4 , 5 , 6 , 7 &gt;&gt; ) |&gt; CustomVariableOpaque . encode_xdr ( ) # Decode CustomVariableOpaque . decode_xdr! ( &lt;&lt; 1 , 2 , 3 , 4 , 5 , 6 , 7 &gt;&gt; )","ref":"variable_length_opaque.html","title":"XDR.VariableOpaque - Variable-Length Opaque","type":"extras"},{"doc":"XDR.String - String Represents a string of n (numbered 0 through n-1) ASCII bytes to be the number n encoded as an unsigned integer (as described above), and followed by the n bytes of the string. If the maximum length is not specified, it is assumed to be 2&lt;sup&gt;32&lt;/sup&gt; - 1. String - RFC 4506","ref":"string.html","title":"XDR.String - String","type":"extras"},{"doc":"Encoding iex(1)&gt; XDR.String . new ( &quot;The little prince&quot; ) |&gt; XDR.String . encode_xdr ( ) { :ok , &lt;&lt; 0 , 0 , 0 , 17 , 84 , 104 , 101 , 32 , 108 , 105 , 116 , 116 , 108 , 101 , 32 , 112 , 114 , 105 , 110 , 99 , 101 , 0 , 0 , 0 &gt;&gt; } iex(1)&gt; XDR.String . new ( &quot;The little prince&quot; ) |&gt; XDR.String . encode_xdr! ( ) &lt;&lt; 0 , 0 , 0 , 17 , 84 , 104 , 101 , 32 , 108 , 105 , 116 , 116 , 108 , 101 , 32 , 112 , 114 , 105 , 110 , 99 , 101 , 0 , 0 , 0 &gt;&gt; Decoding iex(1)&gt; XDR.String . decode_xdr ( &lt;&lt; 0 , 0 , 0 , 17 , 84 , 104 , 101 , 32 , 108 , 105 , 116 , 116 , 108 , 101 , 32 , 112 , 114 , 105 , 110 , 99 , 101 , 0 , 0 , 0 &gt;&gt; ) { :ok , { % XDR.String { max_length : 4294967295 , string : &quot;The little prince&quot; } , &quot;&quot; } } iex(1)&gt; XDR.String . decode_xdr! ( &lt;&lt; 0 , 0 , 0 , 17 , 84 , 104 , 101 , 32 , 108 , 105 , 116 , 116 , 108 , 101 , 32 , 112 , 114 , 105 , 110 , 99 , 101 , 0 , 0 , 0 &gt;&gt; ) { % XDR.String { max_length : 4294967295 , string : &quot;The little prince&quot; } , &quot;&quot; } Custom String example defmodule CustomString do @max_length 28 @type t :: XDR.String . t ( ) @spec new ( text :: binary ( ) ) :: t def new ( text \\\\ nil ) , do : XDR.String . new ( text , @max_length ) defdelegate encode_xdr ( text ) , to : XDR.String defdelegate encode_xdr! ( text ) , to : XDR.String defdelegate decode_xdr ( bytes , string \\\\ new ( ) ) , to : XDR.String defdelegate decode_xdr! ( bytes , string \\\\ new ( ) ) , to : XDR.String end # Encode CustomString . new ( &quot;Example&quot; ) |&gt; CustomString . encode_xdr ( ) # Decode CustomString . decode_xdr! ( &lt;&lt; 0 , 0 , 0 , 7 , 69 , 120 , 97 , 109 , 112 , 108 , 101 , 0 &gt;&gt; )","ref":"string.html#usage","title":"XDR.String - String - Usage","type":"extras"},{"doc":"XDR.FixedArray - Fixed-Length Array Represents a fixed-length array that contains elements with the same type. Fixed-Length Array - RFC 4506","ref":"fixed_length_array.html","title":"XDR.FixedArray - Fixed-Length Array","type":"extras"},{"doc":"Encoding iex(1)&gt; XDR.FixedArray . new ( [ 1 , 2 , 3 ] , XDR.Int , 3 ) |&gt; XDR.FixedArray . encode_xdr ( ) { :ok , &lt;&lt; 0 , 0 , 0 , 1 , 0 , 0 , 0 , 2 , 0 , 0 , 0 , 3 &gt;&gt; } iex(1)&gt; XDR.FixedArray . new ( [ &quot;The&quot; , &quot;little&quot; , &quot;prince&quot; ] , XDR.String , 3 ) |&gt; XDR.FixedArray . encode_xdr! ( ) &lt;&lt; 0 , 0 , 0 , 3 , 84 , 104 , 101 , 0 , 0 , 0 , 0 , 6 , 108 , 105 , 116 , 116 , 108 , 101 , 0 , 0 , 0 , 0 , 0 , 6 , 112 , 114 , 105 , 110 , 99 , 101 , 0 , 0 &gt;&gt; Decoding iex(1)&gt; XDR.FixedArray . decode_xdr ( &lt;&lt; 0 , 0 , 0 , 1 , 0 , 0 , 0 , 2 , 0 , 0 , 0 , 3 &gt;&gt; , %{ type : XDR.Int , length : 3 } ) { :ok , { [ % XDR.Int { datum : 1 } , % XDR.Int { datum : 2 } , % XDR.Int { datum : 3 } ] , &lt;&lt; &gt;&gt; } } iex(1)&gt; XDR.FixedArray . decode_xdr! ( &lt;&lt; 0 , 0 , 0 , 3 , 84 , 104 , 101 , 0 , 0 , 0 , 0 , 6 , 108 , 105 , 116 , 116 , 108 , 101 , 0 , 0 , 0 , 0 , 0 , 6 , 112 , 114 , 105 , 110 , 99 , 101 , 0 , 0 &gt;&gt; , %{ type : XDR.String , length : 3 } ) { [ % XDR.String { max_length : 4294967295 , string : &quot;The&quot; } , % XDR.String { max_length : 4294967295 , string : &quot;little&quot; } , % XDR.String { max_length : 4294967295 , string : &quot;prince&quot; } ] , &lt;&lt; &gt;&gt; } Custom Fixed-Length Array example defmodule CustomFixedArray do @length 3 @type t :: XDR.FixedArray . t ( ) @spec new ( list_items :: list ( XDR.String . t ( ) ) ) :: t def new ( list_items \\\\ [ ] ) when is_list ( list_items ) , do : XDR.FixedArray . new ( list_items , XDR.String , @length ) defdelegate encode_xdr ( fixed_array ) , to : XDR.FixedArray defdelegate encode_xdr! ( fixed_array ) , to : XDR.FixedArray defdelegate decode_xdr ( bytes , fixed_array \\\\ new ( ) ) , to : XDR.FixedArray defdelegate decode_xdr! ( bytes , fixed_array \\\\ new ( ) ) , to : XDR.FixedArray end # Encode CustomFixedArray . new ( [ &quot;item 1&quot; , &quot;item 2&quot; , &quot;item 3&quot; ] ) |&gt; CustomFixedArray . encode_xdr ( ) # Decode CustomFixedArray . decode_xdr! ( &lt;&lt; 0 , 0 , 0 , 3 , 84 , 104 , 101 , 0 , 0 , 0 , 0 , 6 , 108 , 105 , 116 , 116 , 108 , 101 , 0 , 0 , 0 , 0 , 0 , 6 , 112 , 114 , 105 , 110 , 99 , 101 , 0 , 0 &gt;&gt; )","ref":"fixed_length_array.html#usage","title":"XDR.FixedArray - Fixed-Length Array - Usage","type":"extras"},{"doc":"XDR.VariableArray - Variable-Length Array Represents a variable-length array that contains elements with the same type. If the maximum length is not specified, it is assumed to be 2&lt;sup&gt;32&lt;/sup&gt; - 1. Variable-Length Array - RFC 4506","ref":"variable_length_array.html","title":"XDR.VariableArray - Variable-Length Array","type":"extras"},{"doc":"Encoding iex(1)&gt; XDR.VariableArray . new ( [ 1 , 2 , 3 ] , XDR.Int ) |&gt; XDR.VariableArray . encode_xdr ( ) { :ok , &lt;&lt; 0 , 0 , 0 , 3 , 0 , 0 , 0 , 1 , 0 , 0 , 0 , 2 , 0 , 0 , 0 , 3 &gt;&gt; } iex(1)&gt; XDR.VariableArray . new ( [ &quot;The&quot; , &quot;little&quot; , &quot;prince&quot; ] , XDR.String ) |&gt; XDR.VariableArray . encode_xdr! ( ) &lt;&lt; 0 , 0 , 0 , 3 , 0 , 0 , 0 , 3 , 84 , 104 , 101 , 0 , 0 , 0 , 0 , 6 , 108 , 105 , 116 , 116 , 108 , 101 , 0 , 0 , 0 , 0 , 0 , 6 , 112 , 114 , 105 , 110 , 99 , 101 , 0 , 0 &gt;&gt; Decoding iex(1)&gt; XDR.VariableArray . decode_xdr ( &lt;&lt; 0 , 0 , 0 , 3 , 0 , 0 , 0 , 1 , 0 , 0 , 0 , 2 , 0 , 0 , 0 , 3 &gt;&gt; , ... &gt; %{ type : XDR.Int , max_length : 3 } ) { :ok , { [ % XDR.Int { datum : 1 } , % XDR.Int { datum : 2 } , % XDR.Int { datum : 3 } ] , &lt;&lt; &gt;&gt; } } iex(1)&gt; XDR.VariableArray . decode_xdr! ( &lt;&lt; 0 , 0 , 0 , 3 , 0 , 0 , 0 , 3 , 84 , 104 , 101 , 0 , 0 , 0 , 0 , 6 , 108 , 105 , ...&gt; 116 , 116 , 108 , 101 , 0 , 0 , 0 , 0 , 0 , 6 , 112 , 114 , 105 , 110 , 99 , 101 , 0 , 0 &gt;&gt; , ... &gt; %{ type : XDR.String , length : 3 } ) { [ % XDR.String { max_length : 4294967295 , string : &quot;The&quot; } , % XDR.String { max_length : 4294967295 , string : &quot;little&quot; } , % XDR.String { max_length : 4294967295 , string : &quot;prince&quot; } ] , &lt;&lt; &gt;&gt; } Custom Variable-Length Array example defmodule CustomVariableArray do @max_length 100 @type t :: XDR.VariableArray . t ( ) @spec new ( list_items :: list ( XDR.String . t ( ) ) ) :: t def new ( list_items \\\\ [ ] ) when is_list ( list_items ) , do : XDR.VariableArray . new ( list_items , XDR.String , @max_length ) defdelegate encode_xdr ( variable_array ) , to : XDR.VariableArray defdelegate encode_xdr! ( variable_array ) , to : XDR.VariableArray defdelegate decode_xdr ( bytes , variable_array \\\\ new ( ) ) , to : XDR.VariableArray defdelegate decode_xdr! ( bytes , variable_array \\\\ new ( ) ) , to : XDR.VariableArray end # Encode CustomVariableArray . new ( [ &quot;item 1&quot; , &quot;item 2&quot; ] ) |&gt; CustomVariableArray . encode_xdr ( ) # Decode CustomVariableArray . decode_xdr! ( &lt;&lt; 0 , 0 , 2 , 52 &gt;&gt; )","ref":"variable_length_array.html#usage","title":"XDR.VariableArray - Variable-Length Array - Usage","type":"extras"},{"doc":"XDR.Struct - Structure Represents a collection of fields, possibly of different data types, typically in fixed and sequence numbers. Structure - RFC 4506","ref":"structure.html","title":"XDR.Struct - Structure","type":"extras"},{"doc":"Encoding iex(1)&gt; name = XDR.String . new ( &quot;The little prince&quot; ) % XDR.String { max_length : 4294967295 , string : &quot;The little prince&quot; } iex(2)&gt; size = XDR.Int . new ( 298 ) % XDR.Int { datum : 298 } iex(3)&gt; Struct . new ( [ name : name , size : size ] ) |&gt; Struct . encode_xdr ( ) { :ok , &lt;&lt; 0 , 0 , 0 , 17 , 84 , 104 , 101 , 32 , 108 , 105 , 116 , 116 , 108 , 101 , 32 , 112 , 114 , 105 , 110 , 99 , 101 , 0 , 0 , 0 , 0 , 0 , 1 , 42 &gt;&gt; } iex(1)&gt; name = XDR.String . new ( &quot;The little prince&quot; ) % XDR.String { max_length : 4294967295 , string : &quot;The little prince&quot; } iex(2)&gt; size = XDR.Int . new ( 298 ) % XDR.Int { datum : 298 } iex(3)&gt; XDR.Struct . new ( [ name : name , size : size ] ) |&gt; XDR.Struct . encode_xdr! ( ) &lt;&lt; 0 , 0 , 0 , 17 , 84 , 104 , 101 , 32 , 108 , 105 , 116 , 116 , 108 , 101 , 32 , 112 , 114 , 105 , 110 , 99 , 101 , 0 , 0 , 0 , 0 , 0 , 1 , 42 &gt;&gt; Decoding iex(1)&gt; struct_spec = XDR.Struct . new ( [ name : XDR.String , size : XDR.Int ] ) iex(2)&gt; XDR.Struct . decode_xdr ( &lt;&lt; 0 , 0 , 0 , 17 , 84 , 104 , 101 , 32 , 108 , 105 , 116 , 116 , 108 , 101 , 32 , 112 , 114 , 105 , 110 , 99 , 101 , 0 , 0 , 0 , 0 , 0 , 1 , 42 &gt;&gt; , struct_spec ) { :ok , { % XDR.Struct { components : [ name : % XDR.String { max_length : 4294967295 , string : &quot;The little prince&quot; } , size : % XDR.Int { datum : 298 } ] } , &quot;&quot; } } iex(1)&gt; struct_spec = XDR.Struct . new ( [ name : XDR.String , size : XDR.Int ] ) iex(2)&gt; XDR.Struct . decode_xdr! ( &lt;&lt; 0 , 0 , 0 , 17 , 84 , 104 , 101 , 32 , 108 , 105 , 116 , 116 , 108 , 101 , 32 , 112 , 114 , 105 , 110 , 99 , 101 , 0 , 0 , 0 , 0 , 0 , 1 , 42 &gt;&gt; , struct_spec ) { % XDR.Struct { components : [ name : % XDR.String { max_length : 4294967295 , string : &quot;The little prince&quot; } , size : % XDR.Int { datum : 298 } ] } , &quot;&quot; } Custom Structure example defmodule CustomStruct do @struct_spec [ name : XDR.String , age : XDR.UInt ] @type t :: Struct . t ( ) @spec new ( params :: keyword ( ) | struct ( ) ) :: t def new ( params ) , do : Struct . new ( params ) @spec spec ( ) :: t defp spec ( ) , do : new ( @struct_spec ) defdelegate encode_xdr ( struct ) , to : Struct defdelegate encode_xdr! ( struct ) , to : Struct defdelegate decode_xdr ( bytes , struct \\\\ spec ( ) ) , to : Struct defdelegate decode_xdr! ( bytes , struct \\\\ spec ( ) ) , to : Struct end # Encode [ name : &quot;John Doe&quot; , age : % XDR.UInt { datum : 32 } ] |&gt; CustomStruct . new ( ) |&gt; CustomStruct . encode_xdr ( ) # Decode CustomStruct . decode_xdr! ( &lt;&lt; 0 , 0 , 2 , 43 , 1 , 2 , 3 , 52 &gt;&gt; )","ref":"structure.html#usage","title":"XDR.Struct - Structure - Usage","type":"extras"},{"doc":"XDR.Union - Discriminated Union A discriminated union is a type composed of a discriminant followed by a type selected from a set of prearranged types according to the value of the discriminant. The component types are called arms of the union and are preceded by the value of the discriminant that implies their encoding or decoding. Discriminated Union - RFC 4506","ref":"discriminated_union.html","title":"XDR.Union - Discriminated Union","type":"extras"},{"doc":"The type of discriminant is either XDR.Int , XDR.UInt , or an XDR.Enum type. The arms can be a keyword list or a map and the value of each arm can be either a struct or a module of any XDR type. You can define a default arm using :default as a key (The default arm is optional).","ref":"discriminated_union.html#implementation","title":"XDR.Union - Discriminated Union - Implementation","type":"extras"},{"doc":"arms definition For union with enumeration as discriminant: iex(1)&gt; arms = [ case_1 : % XDR.Int { datum : 1 } , case_2 : % XDR.Int { datum : 2 } , case_3 : XDR.Int , default : XDR.Float ] For union with integer as discriminant: iex(1)&gt; arms = %{ 1 =&gt; % XDR.Int { datum : 1 } , 2 =&gt; % XDR.Int { datum : 2 } , 3 =&gt; XDR.Int , default : XDR.Float } Encoding For union with enumeration as discriminant: # encode_xdr iex(1)&gt; XDR.Enum . new ( [ case_1 : 1 , case_2 : 2 ] , :case_1 ) |&gt; ...(1)&gt; XDR.Union . new ( arms ) |&gt; ...(1)&gt; XDR.Union . encode_xdr ( ) { :ok , &lt;&lt; 0 , 0 , 0 , 1 , 0 , 0 , 0 , 1 &gt;&gt; } # encode_xdr! # Using an XDR module to encode. # Note you must to pass the value to encode to the function `XDR.Union.new/3`. iex(1)&gt; XDR.Enum . new ( [ case_1 : 1 , case_2 : 2 , case_3 : 3 ] , :case_3 ) |&gt; ...(1)&gt; XDR.Union . new ( arms , 100 ) |&gt; ...(1)&gt; XDR.Union . encode_xdr! ( ) &lt;&lt; 0 , 0 , 0 , 3 , 0 , 0 , 0 , 100 &gt;&gt; # Encode a default arm. iex(1)&gt; XDR.Enum . new ( [ case_1 : 1 , case_2 : 2 , case_3 : 3 , case_10 : 10 ] , :case_10 ) |&gt; ...(1)&gt; XDR.Union . new ( arms , 12.3333 ) |&gt; ...(1)&gt; XDR.Union . encode_xdr ( ) { :ok , &lt;&lt; 0 , 0 , 0 , 10 , 65 , 69 , 85 , 50 &gt;&gt; } For union with integer as discriminant: iex(1)&gt; XDR.Int . new ( 1 ) |&gt; XDR.Union . new ( arms ) |&gt; XDR.Union . encode_xdr ( ) { :ok , &lt;&lt; 0 , 0 , 0 , 1 , 0 , 0 , 0 , 1 &gt;&gt; } iex(1)&gt; XDR.UInt . new ( 3 ) |&gt; XDR.Union . new ( arms , 100 ) |&gt; XDR.Union . encode_xdr! ( ) &lt;&lt; 0 , 0 , 0 , 3 , 0 , 0 , 0 , 100 &gt;&gt; Decoding For union with enumeration as discriminant: # decode_xdr iex(1)&gt; enum = XDR.Enum . new ( [ case_1 : 1 , case_2 : 2 ] , nil ) iex(2)&gt; union_spec = XDR.Union . new ( enum , arms ) # Define the union specification to decode. iex(3)&gt; XDR.Union . decode_xdr ( &lt;&lt; 0 , 0 , 0 , 1 , 0 , 0 , 0 , 1 &gt;&gt; , union_spec ) { :ok , { { :case_1 , % XDR.Int { datum : 1 } } , &lt;&lt; &gt;&gt; } } # decode_xdr! iex(1)&gt; enum = XDR.Enum . new ( [ case_1 : 1 , case_2 : 2 ] , nil ) iex(2)&gt; union_spec = %{ discriminant : enum , arms : arms } # Also you can pass a map as union specification. iex(3)&gt; XDR.Union . decode_xdr! ( &lt;&lt; 0 , 0 , 0 , 2 , 0 , 0 , 0 , 20 &gt;&gt; , union_spec ) { { :case_2 , % XDR.Int { datum : 20 } } , &lt;&lt; &gt;&gt; } # Decode a default arm. iex(1)&gt; enum = XDR.Enum . new ( [ case_1 : 1 , case_2 : 2 , case_3 : 3 , case_10 : 10 ] , :case_10 ) ...(1)&gt; union_spec = XDR.Union . new ( enum , arms ) ...(1)&gt; XDR.Union . decode_xdr ( &lt;&lt; 0 , 0 , 0 , 10 , 65 , 69 , 85 , 50 &gt;&gt; , union_spec ) { :ok , { { :case_10 , % XDR.Float { float : 12.33329963684082 } } , &quot;&quot; } } For union with integer as discriminant: # decode_xdr iex(1)&gt; integer = XDR.Int . new ( nil ) iex(2)&gt; union_spec = XDR.Union . new ( integer , arms ) iex(3)&gt; XDR.Union . decode_xdr ( &lt;&lt; 0 , 0 , 0 , 1 , 0 , 0 , 0 , 1 &gt;&gt; , union_spec ) { :ok , { { 1 , % XDR.Int { datum : 1 } } , &lt;&lt; &gt;&gt; } } #decode_xdr! iex(1)&gt; integer = XDR.UInt . new ( nil ) iex(2)&gt; union_spec = XDR.Union . new ( integer , arms ) iex(3)&gt; XDR.Union . decode_xdr! ( &lt;&lt; 0 , 0 , 0 , 2 , 0 , 0 , 0 , 7 &gt;&gt; , union_spec ) { { 2 , % XDR.Int { datum : 7 } } , &lt;&lt; &gt;&gt; } Custom Union example defmodule CustomUnion do @arms [ Type_1 : Type1 , Type_2 : Type2 , default : XDR.Void ] @type t :: XDR.Union . t ( ) @spec new ( value :: any ( ) , union_type :: atom ( ) ) :: t def new ( value , union_type ) do union_type |&gt; CustomEnum . new ( ) |&gt; XDR.Union . new ( @arms , value ) end @spec spec ( ) :: t defp spec ( ) , do : CustomEnum . new ( nil ) |&gt; Union . new ( @arms ) defdelegate encode_xdr ( union ) , to : XDR.Union defdelegate encode_xdr! ( union ) , to : XDR.Union defdelegate decode_xdr ( bytes , union \\\\ spec ( ) ) , to : XDR.Union defdelegate decode_xdr! ( bytes , union \\\\ spec ( ) ) , to : XDR.Union end # Encode value_depending_on_the_type |&gt; CustomUnion . new ( :type_1 ) |&gt; CustomUnion . encode_xdr ( ) # Decode CustomUnion . decode_xdr ( &lt;&lt; 1 , 2 , 3 , 4 , 5 , 6 , 7 , 8 &gt;&gt; )","ref":"discriminated_union.html#usage","title":"XDR.Union - Discriminated Union - Usage","type":"extras"},{"doc":"XDR.Void - Void Represents a 0-byte quantity. Voids are useful for describing operations that take no data as input or no data as output. Void - RFC 4506","ref":"void.html","title":"XDR.Void - Void","type":"extras"},{"doc":"Encoding iex(1)&gt; XDR.Void . new ( nil ) |&gt; XDR.Void . encode_xdr ( ) { :ok , &lt;&lt; &gt;&gt; } iex(1)&gt; XDR.Void . new ( ) |&gt; XDR.Void . encode_xdr! ( ) &lt;&lt; &gt;&gt; Decoding iex(1)&gt; XDR.Void . decode_xdr ( &lt;&lt; &gt;&gt; ) { :ok , { nil , &lt;&lt; &gt;&gt; } } iex(1)&gt; XDR.Void . decode_xdr! ( &lt;&lt; 72 , 101 , 108 , 108 , 111 &gt;&gt; ) { nil , &lt;&lt; 72 , 101 , 108 , 108 , 111 , 0 &gt;&gt; } Custom Void example defmodule CustomVoid do @type t :: XDR.Void . t ( ) defdelegate new ( ) , to : XDR.Void defdelegate encode_xdr ( void ) , to : XDR.Void defdelegate encode_xdr! ( void ) , to : XDR.Void defdelegate decode_xdr ( bytes ) , to : XDR.Void defdelegate decode_xdr! ( bytes ) , to : XDR.Void end # Encode CustomVoid . new ( ) |&gt; CustomVoid . encode_xdr ( ) # Decode CustomVoid . decode_xdr! ( &lt;&lt; &gt;&gt; )","ref":"void.html#usage","title":"XDR.Void - Void - Usage","type":"extras"},{"doc":"XDR.Optional - Optional-Data Represents one kind of union that occurs so frequently that we give it a special syntax of its own for declaring it. An optional-data could be any XDR type of data or XDR.Void . Optional-Data - RFC 4506","ref":"optional_data.html","title":"XDR.Optional - Optional-Data","type":"extras"},{"doc":"Encoding iex(1)&gt; XDR.String . new ( &quot;this is an example.&quot; ) |&gt; XDR.Optional . new ( ) |&gt; XDR.Optional . encode_xdr ( ) { :ok , &lt;&lt; 0 , 0 , 0 , 1 , 0 , 0 , 0 , 19 , 116 , 104 , 105 , 115 , 32 , 105 , 115 , 32 , 97 , 110 , 32 , 101 , 120 , 97 , 109 , 112 , 108 , 101 , 46 , 0 &gt;&gt; } iex(1)&gt; XDR.Optional . new ( nil ) |&gt; XDR.Optional . encode_xdr! ( ) &lt;&lt; 0 , 0 , 0 , 0 &gt;&gt; Decoding iex(1)&gt; optional_spec = XDR.Optional . new ( XDR.String ) iex(2)&gt; XDR.Optional . decode_xdr ( &lt;&lt; 0 , 0 , 0 , 1 , 0 , 0 , 0 , 19 , 116 , 104 , 105 , 115 , 32 , 105 , 115 , 32 , 97 , 110 , 32 , 101 , 120 , 97 , 109 , 112 , 108 , 101 , 46 , 0 &gt;&gt; , optional_spec ) { :ok , { % XDR.Optional { type : % XDR.String { max_length : 4294967295 , string : &quot;this is an example&quot; } } , &quot;&quot; } } iex ( 1 ) &gt; optional_spec = XDR.Optional . new ( XDR.String ) iex(2)&gt; XDR.Optional . decode_xdr! ( &lt;&lt; 0 , 0 , 0 , 0 &gt;&gt; , optional_spec ) { nil , &quot;&quot; } Custom Optional-Data example defmodule CustomOptional do @type t :: XDR.Optional . t ( ) @spec new ( number :: XDR.Int . t ( ) ) :: t def new ( number \\\\ nil ) , do : XDR.Optional . new ( time_bounds ) @spec spec ( ) :: t defp spec ( ) , do : XDR.Int |&gt; new ( ) defdelegate encode_xdr ( optional_number ) , to : XDR.Optional defdelegate encode_xdr! ( optional_number ) , to : XDR.Optional defdelegate decode_xdr ( bytes , optional_number \\\\ spec ( ) ) , to : XDR.Optional defdelegate decode_xdr! ( bytes , optional_number \\\\ spec ( ) ) , to : XDR.Optional end # Encode XDR.Int . new ( 123 ) |&gt; CustomOptional . new ( ) |&gt; CustomOptional . encode_xdr ( ) # Decode CustomOptional . decode_xdr! ( &lt;&lt; 0 , 0 , 0 , 0 &gt;&gt; )","ref":"optional_data.html#usage","title":"XDR.Optional - Optional-Data - Usage","type":"extras"}]